/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


/* Line 371 of yacc.c  */
#line 588 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     S = 282,
     MS = 283,
     US = 284,
     LOG = 285,
     SYSLOG = 286,
     ALL = 287,
     DEBUG = 288,
     TRACE = 289,
     INFO = 290,
     REMOTE = 291,
     WARNING = 292,
     ERROR = 293,
     AUTH = 294,
     FATAL = 295,
     BUG = 296,
     STDERR = 297,
     SOFT = 298,
     TIMEFORMAT = 299,
     ISO = 300,
     OLD = 301,
     SHORT = 302,
     LONG = 303,
     BASE = 304,
     NAME = 305,
     CONFIRM = 306,
     UNDO = 307,
     CHECK = 308,
     TIMEOUT = 309,
     CONFIGURE = 310,
     DOWN = 311,
     KERNEL = 312,
     PERSIST = 313,
     SCAN = 314,
     TIME = 315,
     LEARN = 316,
     DEVICE = 317,
     ROUTES = 318,
     KRT_SOURCE = 319,
     KRT_METRIC = 320,
     TABLE = 321,
     KRT_PREFSRC = 322,
     KRT_REALM = 323,
     ROUTER = 324,
     ID = 325,
     PROTOCOL = 326,
     TEMPLATE = 327,
     PREFERENCE = 328,
     DISABLED = 329,
     DIRECT = 330,
     INTERFACE = 331,
     IMPORT = 332,
     EXPORT = 333,
     FILTER = 334,
     NONE = 335,
     STATES = 336,
     FILTERS = 337,
     RECEIVE = 338,
     LIMIT = 339,
     ACTION = 340,
     WARN = 341,
     BLOCK = 342,
     RESTART = 343,
     DISABLE = 344,
     KEEP = 345,
     FILTERED = 346,
     PASSWORD = 347,
     FROM = 348,
     PASSIVE = 349,
     TO = 350,
     EVENTS = 351,
     PACKETS = 352,
     PROTOCOLS = 353,
     INTERFACES = 354,
     PRIMARY = 355,
     STATS = 356,
     COUNT = 357,
     FOR = 358,
     COMMANDS = 359,
     PREEXPORT = 360,
     GENERATE = 361,
     ROA = 362,
     MAX = 363,
     FLUSH = 364,
     AS = 365,
     LISTEN = 366,
     BGP = 367,
     V6ONLY = 368,
     DUAL = 369,
     ADDRESS = 370,
     PORT = 371,
     PASSWORDS = 372,
     DESCRIPTION = 373,
     SORTED = 374,
     RELOAD = 375,
     IN = 376,
     OUT = 377,
     MRTDUMP = 378,
     MESSAGES = 379,
     RESTRICT = 380,
     MEMORY = 381,
     IGP_METRIC = 382,
     CLASS = 383,
     DSCP = 384,
     SHOW = 385,
     STATUS = 386,
     SUMMARY = 387,
     ROUTE = 388,
     SYMBOLS = 389,
     ADD = 390,
     DELETE = 391,
     DUMP = 392,
     RESOURCES = 393,
     SOCKETS = 394,
     NEIGHBORS = 395,
     ATTRIBUTES = 396,
     EVAL = 397,
     ECHO = 398,
     ENABLE = 399,
     FUNCTION = 400,
     PRINT = 401,
     PRINTN = 402,
     UNSET = 403,
     RETURN = 404,
     ACCEPT = 405,
     REJECT = 406,
     QUITBIRD = 407,
     INT = 408,
     BOOL = 409,
     IP = 410,
     PREFIX = 411,
     PAIR = 412,
     QUAD = 413,
     EC = 414,
     SET = 415,
     STRING = 416,
     BGPMASK = 417,
     BGPPATH = 418,
     CLIST = 419,
     ECLIST = 420,
     IF = 421,
     THEN = 422,
     ELSE = 423,
     CASE = 424,
     TRUE = 425,
     FALSE = 426,
     RT = 427,
     RO = 428,
     UNKNOWN = 429,
     GENERIC = 430,
     GW = 431,
     NET = 432,
     MASK = 433,
     PROTO = 434,
     SOURCE = 435,
     SCOPE = 436,
     CAST = 437,
     DEST = 438,
     IFNAME = 439,
     IFINDEX = 440,
     LEN = 441,
     DEFINED = 442,
     CONTAINS = 443,
     RESET = 444,
     PREPEND = 445,
     FIRST = 446,
     LAST = 447,
     MATCH = 448,
     ROA_CHECK = 449,
     EMPTY = 450,
     WHERE = 451,
     BFD = 452,
     MIN = 453,
     IDLE = 454,
     RX = 455,
     TX = 456,
     INTERVAL = 457,
     MULTIPLIER = 458,
     MULTIHOP = 459,
     NEIGHBOR = 460,
     DEV = 461,
     LOCAL = 462,
     SESSIONS = 463,
     HOLD = 464,
     CONNECT = 465,
     RETRY = 466,
     KEEPALIVE = 467,
     STARTUP = 468,
     VIA = 469,
     NEXT = 470,
     HOP = 471,
     SELF = 472,
     DEFAULT = 473,
     PATH = 474,
     METRIC = 475,
     START = 476,
     DELAY = 477,
     FORGET = 478,
     WAIT = 479,
     AFTER = 480,
     BGP_PATH = 481,
     BGP_LOCAL_PREF = 482,
     BGP_MED = 483,
     BGP_ORIGIN = 484,
     BGP_NEXT_HOP = 485,
     BGP_ATOMIC_AGGR = 486,
     BGP_AGGREGATOR = 487,
     BGP_COMMUNITY = 488,
     BGP_EXT_COMMUNITY = 489,
     RR = 490,
     RS = 491,
     CLIENT = 492,
     CLUSTER = 493,
     AS4 = 494,
     ADVERTISE = 495,
     IPV4 = 496,
     CAPABILITIES = 497,
     PREFER = 498,
     OLDER = 499,
     MISSING = 500,
     LLADDR = 501,
     DROP = 502,
     IGNORE = 503,
     REFRESH = 504,
     INTERPRET = 505,
     COMMUNITIES = 506,
     BGP_ORIGINATOR_ID = 507,
     BGP_CLUSTER_LIST = 508,
     IGP = 509,
     GATEWAY = 510,
     RECURSIVE = 511,
     MED = 512,
     TTL = 513,
     SECURITY = 514,
     DETERMINISTIC = 515,
     SECONDARY = 516,
     ALLOW = 517,
     OSPF = 518,
     AREA = 519,
     OSPF_METRIC1 = 520,
     OSPF_METRIC2 = 521,
     OSPF_TAG = 522,
     OSPF_ROUTER_ID = 523,
     RFC1583COMPAT = 524,
     STUB = 525,
     TICK = 526,
     COST = 527,
     COST2 = 528,
     RETRANSMIT = 529,
     HELLO = 530,
     TRANSMIT = 531,
     PRIORITY = 532,
     DEAD = 533,
     TYPE = 534,
     BROADCAST = 535,
     BCAST = 536,
     NONBROADCAST = 537,
     NBMA = 538,
     POINTOPOINT = 539,
     PTP = 540,
     POINTOMULTIPOINT = 541,
     PTMP = 542,
     SIMPLE = 543,
     AUTHENTICATION = 544,
     STRICT = 545,
     CRYPTOGRAPHIC = 546,
     ELIGIBLE = 547,
     POLL = 548,
     NETWORKS = 549,
     HIDDEN = 550,
     VIRTUAL = 551,
     LINK = 552,
     ONLY = 553,
     BUFFER = 554,
     LARGE = 555,
     NORMAL = 556,
     STUBNET = 557,
     TAG = 558,
     EXTERNAL = 559,
     LSADB = 560,
     ECMP = 561,
     WEIGHT = 562,
     NSSA = 563,
     TRANSLATOR = 564,
     STABILITY = 565,
     GLOBAL = 566,
     LSID = 567,
     INSTANCE = 568,
     REAL = 569,
     NETMASK = 570,
     TOPOLOGY = 571,
     STATE = 572,
     PIPE = 573,
     PEER = 574,
     MODE = 575,
     OPAQUE = 576,
     TRANSPARENT = 577,
     RADV = 578,
     RA = 579,
     MANAGED = 580,
     OTHER = 581,
     CONFIG = 582,
     MTU = 583,
     REACHABLE = 584,
     RETRANS = 585,
     TIMER = 586,
     CURRENT = 587,
     VALID = 588,
     PREFERRED = 589,
     MULT = 590,
     LIFETIME = 591,
     SKIP = 592,
     ONLINK = 593,
     AUTONOMOUS = 594,
     RDNSS = 595,
     DNSSL = 596,
     NS = 597,
     DOMAIN = 598,
     TRIGGER = 599,
     SENSITIVE = 600,
     RIP = 601,
     INFINITY = 602,
     PERIOD = 603,
     GARBAGE = 604,
     MULTICAST = 605,
     QUIET = 606,
     NOLISTEN = 607,
     VERSION1 = 608,
     PLAINTEXT = 609,
     MD5 = 610,
     HONOR = 611,
     NEVER = 612,
     ALWAYS = 613,
     RIP_METRIC = 614,
     RIP_TAG = 615,
     STATIC = 616,
     PROHIBIT = 617,
     MULTIPATH = 618,
     BLACKHOLE = 619,
     UNREACHABLE = 620
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 516 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 1024 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1052 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2825

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  387
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  285
/* YYNRULES -- Number of rules.  */
#define YYNRULES  889
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1665

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   620

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     378,   379,    28,    26,   383,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   380,   377,
      23,    22,    24,   384,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   385,     2,   386,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   381,     2,   382,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    58,    60,    62,    65,    68,    70,
      72,    73,    78,    81,    82,    84,    87,    89,    91,    95,
      97,   101,   103,   105,   107,   109,   111,   113,   115,   117,
     119,   124,   128,   130,   132,   134,   136,   139,   144,   148,
     152,   156,   160,   164,   169,   175,   179,   183,   188,   191,
     192,   194,   195,   197,   200,   203,   206,   210,   213,   217,
     220,   224,   228,   232,   237,   243,   245,   247,   249,   254,
     255,   258,   261,   264,   266,   268,   269,   271,   275,   279,
     280,   289,   291,   296,   298,   300,   301,   303,   307,   308,
     311,   314,   317,   320,   323,   326,   330,   334,   338,   343,
     346,   350,   353,   356,   358,   360,   362,   363,   366,   369,
     372,   375,   378,   380,   382,   386,   390,   391,   393,   395,
     398,   399,   401,   405,   407,   411,   412,   415,   418,   421,
     424,   428,   432,   436,   437,   441,   443,   445,   449,   451,
     455,   457,   459,   461,   463,   465,   467,   469,   471,   475,
     477,   481,   483,   485,   490,   492,   493,   497,   502,   504,
     507,   508,   514,   520,   526,   532,   537,   541,   545,   550,
     556,   558,   559,   563,   568,   573,   574,   577,   581,   585,
     589,   592,   595,   598,   601,   605,   609,   612,   615,   617,
     619,   624,   625,   629,   633,   637,   638,   640,   642,   647,
     648,   651,   654,   657,   660,   663,   666,   669,   670,   673,
     683,   693,   698,   702,   706,   710,   714,   718,   722,   726,
     730,   735,   737,   739,   743,   744,   746,   750,   754,   758,
     762,   767,   772,   777,   782,   785,   787,   789,   791,   793,
     794,   796,   797,   802,   805,   807,   809,   811,   813,   815,
     817,   819,   821,   823,   825,   827,   829,   832,   835,   836,
     840,   842,   846,   848,   850,   852,   855,   859,   862,   867,
     868,   874,   875,   877,   879,   882,   884,   888,   890,   892,
     894,   896,   898,   900,   904,   906,   908,   910,   912,   914,
     918,   920,   926,   938,   940,   942,   944,   947,   949,   957,
     967,   975,   977,   979,   981,   985,   987,   989,   991,   995,
     997,  1001,  1003,  1007,  1011,  1013,  1016,  1019,  1026,  1028,
    1032,  1033,  1038,  1042,  1044,  1048,  1052,  1056,  1059,  1062,
    1065,  1068,  1069,  1072,  1075,  1076,  1078,  1080,  1082,  1084,
    1086,  1088,  1090,  1094,  1098,  1100,  1102,  1108,  1116,  1117,
    1122,  1124,  1126,  1128,  1130,  1132,  1134,  1136,  1138,  1140,
    1142,  1144,  1148,  1152,  1156,  1160,  1164,  1168,  1172,  1176,
    1180,  1184,  1188,  1192,  1196,  1200,  1203,  1208,  1210,  1212,
    1214,  1216,  1219,  1222,  1226,  1230,  1237,  1241,  1245,  1249,
    1253,  1259,  1266,  1273,  1280,  1287,  1292,  1301,  1306,  1308,
    1310,  1312,  1314,  1316,  1318,  1320,  1321,  1323,  1327,  1329,
    1333,  1334,  1336,  1341,  1348,  1353,  1357,  1363,  1369,  1374,
    1381,  1385,  1388,  1394,  1400,  1409,  1418,  1427,  1436,  1439,
    1441,  1444,  1447,  1450,  1451,  1455,  1461,  1462,  1465,  1470,
    1475,  1480,  1483,  1486,  1487,  1491,  1492,  1496,  1500,  1503,
    1504,  1507,  1510,  1511,  1514,  1515,  1518,  1523,  1529,  1532,
    1536,  1540,  1546,  1553,  1561,  1568,  1573,  1578,  1584,  1591,
    1598,  1604,  1608,  1612,  1617,  1623,  1629,  1635,  1641,  1647,
    1652,  1657,  1663,  1669,  1675,  1681,  1687,  1693,  1699,  1705,
    1712,  1719,  1728,  1735,  1742,  1748,  1753,  1759,  1764,  1770,
    1775,  1781,  1786,  1792,  1799,  1805,  1811,  1816,  1819,  1823,
    1827,  1829,  1832,  1836,  1839,  1844,  1847,  1849,  1852,  1857,
    1858,  1862,  1865,  1867,  1870,  1874,  1878,  1882,  1886,  1889,
    1893,  1894,  1900,  1901,  1907,  1910,  1913,  1915,  1920,  1922,
    1924,  1925,  1929,  1932,  1935,  1938,  1944,  1947,  1948,  1952,
    1953,  1956,  1959,  1963,  1966,  1969,  1973,  1976,  1979,  1982,
    1984,  1988,  1991,  1994,  1997,  2000,  2003,  2006,  2010,  2013,
    2016,  2019,  2022,  2025,  2028,  2031,  2034,  2038,  2042,  2046,
    2049,  2053,  2056,  2060,  2064,  2069,  2072,  2075,  2078,  2082,
    2086,  2090,  2093,  2097,  2101,  2106,  2109,  2111,  2112,  2115,
    2119,  2121,  2122,  2124,  2127,  2128,  2131,  2132,  2134,  2138,
    2139,  2140,  2143,  2144,  2148,  2149,  2153,  2158,  2160,  2161,
    2166,  2173,  2180,  2187,  2195,  2202,  2210,  2216,  2217,  2220,
    2224,  2227,  2231,  2235,  2238,  2242,  2245,  2248,  2252,  2256,
    2262,  2267,  2272,  2275,  2277,  2280,  2283,  2284,  2288,  2289,
    2293,  2296,  2297,  2301,  2307,  2308,  2313,  2318,  2322,  2325,
    2329,  2333,  2337,  2341,  2346,  2351,  2354,  2355,  2359,  2360,
    2364,  2368,  2372,  2373,  2374,  2378,  2379,  2383,  2388,  2390,
    2393,  2396,  2399,  2404,  2409,  2410,  2411,  2415,  2416,  2420,
    2424,  2426,  2427,  2428,  2431,  2434,  2435,  2436,  2440,  2442,
    2448,  2450,  2451,  2452,  2455,  2458,  2459,  2460,  2464,  2466,
    2472,  2474,  2477,  2478,  2481,  2484,  2488,  2492,  2497,  2502,
    2507,  2513,  2519,  2524,  2528,  2533,  2538,  2543,  2548,  2550,
    2552,  2554,  2556,  2558,  2560,  2562,  2564,  2565,  2568,  2571,
    2574,  2578,  2582,  2587,  2588,  2592,  2593,  2597,  2598,  2602,
    2605,  2609,  2613,  2619,  2625,  2629,  2632,  2636,  2640,  2642,
    2645,  2650,  2654,  2658,  2662,  2665,  2668,  2671,  2674,  2677,
    2682,  2684,  2686,  2688,  2690,  2692,  2694,  2696,  2698,  2700,
    2702,  2704,  2706,  2708,  2710,  2712,  2714,  2716,  2718,  2720,
    2722,  2724,  2726,  2728,  2730,  2732,  2734,  2736,  2738,  2740,
    2742,  2744,  2746,  2748,  2750,  2752,  2754,  2756,  2758,  2760,
    2762,  2764,  2766,  2768,  2770,  2772,  2774,  2776,  2778,  2780,
    2782,  2784,  2786,  2788,  2790,  2792,  2794,  2796,  2798,  2800,
    2802,  2805,  2808,  2811,  2813,  2816,  2819,  2822,  2824,  2827,
    2830,  2834,  2838,  2842,  2846,  2850,  2854,  2858,  2860,  2862,
    2864,  2866,  2868,  2870,  2872,  2874,  2876,  2878,  2880,  2882,
    2884,  2886,  2888,  2890,  2892,  2894,  2896,  2898,  2900,  2902
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     388,     0,    -1,   389,     3,    -1,     4,   667,    -1,    -1,
     389,   666,    -1,    33,    19,    22,   550,   377,    -1,    15,
      -1,   378,   550,   379,    -1,    19,    -1,   391,    38,    -1,
     391,    39,    -1,   391,    40,    -1,   391,    -1,    34,    -1,
      36,    -1,    35,    -1,    37,    -1,    -1,    18,    -1,    19,
      -1,    -1,    30,    19,    -1,   394,   398,    -1,   396,    -1,
     394,    -1,    29,   391,    -1,   380,   394,    -1,    20,    -1,
      20,    -1,    -1,    41,   403,   404,   377,    -1,    61,    20,
      -1,    -1,    20,    -1,    42,   402,    -1,    53,    -1,    43,
      -1,   381,   405,   382,    -1,   406,    -1,   405,   383,   406,
      -1,    44,    -1,    45,    -1,    46,    -1,    47,    -1,    48,
      -1,    49,    -1,    50,    -1,    51,    -1,    52,    -1,   134,
     109,   457,   377,    -1,   134,    20,   377,    -1,   144,    -1,
      82,    -1,    60,    -1,    41,    -1,   408,    20,    -1,   408,
      20,   391,    20,    -1,   408,    56,    58,    -1,   408,    56,
      59,    -1,   408,    57,    58,    -1,   408,    57,    59,    -1,
      55,   409,   377,    -1,    66,   417,   418,     3,    -1,    66,
      54,   417,   418,     3,    -1,    66,    62,     3,    -1,    66,
      63,     3,    -1,    66,    64,   417,     3,    -1,    67,     3,
      -1,    -1,    20,    -1,    -1,    65,    -1,    65,   391,    -1,
     434,    68,    -1,    69,   393,    -1,    70,    71,   391,    -1,
      72,   393,    -1,    73,    74,   393,    -1,   434,    73,    -1,
      70,    71,   391,    -1,   111,   400,   397,    -1,    68,    77,
     391,    -1,    80,    81,   425,   377,    -1,    80,    81,   104,
     448,   377,    -1,    15,    -1,    17,    -1,    18,    -1,   122,
     123,   427,   377,    -1,    -1,   427,   428,    -1,   126,   394,
      -1,   127,   391,    -1,   124,    -1,   125,    -1,    -1,   130,
      -1,    77,    19,   429,    -1,   118,    77,    19,    -1,    -1,
     432,   118,   396,   119,    15,   121,    15,   377,    -1,   431,
      -1,   431,   381,   432,   382,    -1,    82,    -1,    83,    -1,
      -1,    19,    -1,    19,   104,    19,    -1,    -1,    84,   391,
      -1,    85,   393,    -1,    44,   454,    -1,   134,   457,    -1,
      88,   437,    -1,    89,   437,    -1,    94,    95,   439,    -1,
      88,    95,   439,    -1,    89,    95,   439,    -1,    88,   101,
     102,   393,    -1,    77,   440,    -1,    80,    81,   425,    -1,
     129,    20,    -1,    90,   514,    -1,   515,    -1,    43,    -1,
      91,    -1,    -1,    96,    97,    -1,    96,    98,    -1,    96,
      99,    -1,    96,   100,    -1,   391,   438,    -1,    35,    -1,
      19,    -1,    44,   109,   454,    -1,    44,   115,   391,    -1,
      -1,    20,    -1,   397,    -1,    20,   397,    -1,    -1,    27,
      -1,   442,   444,   443,    -1,   445,    -1,   446,   383,   445,
      -1,    -1,   447,   446,    -1,   139,   391,    -1,   140,   391,
      -1,   434,    86,    -1,   450,   435,   381,    -1,   451,   436,
     377,    -1,   451,   453,   377,    -1,    -1,    87,   452,   446,
      -1,    43,    -1,    35,    -1,   381,   455,   382,    -1,   456,
      -1,   455,   383,   456,    -1,    92,    -1,    74,    -1,    93,
      -1,   110,    -1,   107,    -1,   108,    -1,    43,    -1,    35,
      -1,   381,   458,   382,    -1,   459,    -1,   458,   383,   459,
      -1,    92,    -1,   135,    -1,   128,   381,   461,   382,    -1,
     462,    -1,    -1,   462,   377,   461,    -1,   463,   381,   464,
     382,    -1,   463,    -1,   103,    20,    -1,    -1,   117,   104,
     399,   377,   464,    -1,   117,   106,   399,   377,   464,    -1,
     161,   104,   399,   377,   464,    -1,   161,   106,   399,   377,
     464,    -1,    81,   391,   377,   464,    -1,   141,   142,     3,
      -1,   141,   137,     3,    -1,   141,   109,   505,     3,    -1,
     141,   109,    43,   505,     3,    -1,    19,    -1,    -1,   141,
     110,     3,    -1,   141,   110,   143,     3,    -1,   141,   144,
     473,     3,    -1,    -1,   473,   396,    -1,   473,   114,   397,
      -1,   473,    77,    19,    -1,   473,    90,   514,    -1,   473,
     515,    -1,   473,    43,    -1,   473,   111,    -1,   473,   102,
      -1,   473,   474,    19,    -1,   473,    82,    19,    -1,   473,
     112,    -1,   473,   113,    -1,   116,    -1,    89,    -1,   141,
     118,   476,     3,    -1,    -1,   476,   477,   396,    -1,   476,
     121,    15,    -1,   476,    77,    19,    -1,    -1,   132,    -1,
     114,    -1,   141,   145,   479,     3,    -1,    -1,   479,    77,
      -1,   479,   156,    -1,   479,    90,    -1,   479,    82,    -1,
     479,    83,    -1,   479,   118,    -1,   479,    19,    -1,    -1,
      77,    19,    -1,   146,   118,   396,   119,    15,   121,    15,
     480,     3,    -1,   147,   118,   396,   119,    15,   121,    15,
     480,     3,    -1,   120,   118,   480,     3,    -1,   148,   149,
       3,    -1,   148,   150,     3,    -1,   148,   110,     3,    -1,
     148,   151,     3,    -1,   148,   152,     3,    -1,   148,    74,
       3,    -1,   148,   109,     3,    -1,   153,   550,     3,    -1,
     154,   493,   494,     3,    -1,    43,    -1,    35,    -1,   381,
     405,   382,    -1,    -1,    15,    -1,   100,   504,     3,    -1,
     155,   504,     3,    -1,    99,   504,     3,    -1,   131,   504,
       3,    -1,   131,   132,   504,     3,    -1,   131,   133,   504,
       3,    -1,    44,   504,   454,     3,    -1,   134,   504,   457,
       3,    -1,   136,     3,    -1,    19,    -1,    43,    -1,    20,
      -1,    19,    -1,    -1,    20,    -1,    -1,    90,    19,   507,
     513,    -1,   153,   550,    -1,   164,    -1,   165,    -1,   166,
      -1,   167,    -1,   168,    -1,   169,    -1,   170,    -1,   172,
      -1,   173,    -1,   174,    -1,   175,    -1,   176,    -1,   509,
     171,    -1,   509,    19,    -1,    -1,   510,   377,   511,    -1,
     510,    -1,   510,   377,   512,    -1,   517,    -1,    19,    -1,
     513,    -1,   207,   550,    -1,   378,   512,   379,    -1,   378,
     379,    -1,   511,   381,   520,   382,    -1,    -1,   156,    19,
     519,   516,   517,    -1,    -1,   521,    -1,   556,    -1,   521,
     556,    -1,   556,    -1,   381,   520,   382,    -1,    18,    -1,
     391,    -1,    17,    -1,   523,    -1,    16,    -1,    15,    -1,
     378,   550,   379,    -1,    17,    -1,   523,    -1,    16,    -1,
     550,    -1,   526,    -1,   526,     7,   526,    -1,    28,    -1,
     378,   527,   383,   527,   379,    -1,   378,   527,   383,   527,
     379,     7,   378,   526,   383,   526,   379,    -1,   550,    -1,
     183,    -1,   184,    -1,   185,    15,    -1,   186,    -1,   378,
     530,   383,   529,   383,   529,   379,    -1,   378,   530,   383,
     529,   383,   529,     7,   529,   379,    -1,   378,   530,   383,
     529,   383,    28,   379,    -1,   528,    -1,   531,    -1,   524,
      -1,   524,     7,   524,    -1,   528,    -1,   531,    -1,   525,
      -1,   525,     7,   525,    -1,   532,    -1,   534,   383,   532,
      -1,   533,    -1,   535,   383,   533,    -1,    18,    29,    15,
      -1,   536,    -1,   536,    26,    -1,   536,    27,    -1,   536,
     381,    15,   383,    15,   382,    -1,   537,    -1,   538,   383,
     537,    -1,    -1,   539,   535,   380,   520,    -1,   539,     6,
     520,    -1,   548,    -1,   378,   550,   379,    -1,    13,   542,
      14,    -1,    29,   543,    29,    -1,    15,   542,    -1,    28,
     542,    -1,   384,   542,    -1,   540,   542,    -1,    -1,    15,
     543,    -1,   384,   543,    -1,    -1,    15,    -1,   181,    -1,
     182,    -1,    20,    -1,   523,    -1,   536,    -1,    17,    -1,
     385,   534,   386,    -1,   385,   538,   386,    -1,    16,    -1,
     541,    -1,   378,   550,   383,   550,   379,    -1,   378,   530,
     383,   550,   383,   550,   379,    -1,    -1,    19,   378,   555,
     379,    -1,    19,    -1,   104,    -1,   187,    -1,   188,    -1,
     190,    -1,   191,    -1,   192,    -1,   193,    -1,   194,    -1,
     195,    -1,   196,    -1,   378,   550,   379,    -1,   550,    26,
     550,    -1,   550,    27,   550,    -1,   550,    28,   550,    -1,
     550,    29,   550,    -1,   550,    11,   550,    -1,   550,    12,
     550,    -1,   550,    22,   550,    -1,   550,    10,   550,    -1,
     550,    23,   550,    -1,   550,     9,   550,    -1,   550,    24,
     550,    -1,   550,     8,   550,    -1,   550,    25,   550,    -1,
      31,   550,    -1,   198,   378,   550,   379,    -1,   548,    -1,
     544,    -1,   545,    -1,    84,    -1,   546,   549,    -1,   546,
     671,    -1,   550,    32,   166,    -1,   550,    32,   197,    -1,
     550,    32,   189,   378,   550,   379,    -1,   550,    32,   202,
      -1,   550,    32,   203,    -1,    26,   206,    26,    -1,    27,
     206,    27,    -1,    27,    27,   206,    27,    27,    -1,   201,
     378,   550,   383,   550,   379,    -1,   146,   378,   550,   383,
     550,   379,    -1,   147,   378,   550,   383,   550,   379,    -1,
      90,   378,   550,   383,   550,   379,    -1,   205,   378,    19,
     379,    -1,   205,   378,    19,   383,   550,   383,   550,   379,
      -1,    19,   378,   555,   379,    -1,   163,    -1,   161,    -1,
     162,    -1,    49,    -1,   157,    -1,   158,    -1,   550,    -1,
      -1,   552,    -1,   552,   383,   553,    -1,   550,    -1,   550,
     383,   554,    -1,    -1,   554,    -1,   177,   550,   178,   522,
      -1,   177,   550,   178,   522,   179,   522,    -1,    19,    22,
     550,   377,    -1,   160,   550,   377,    -1,   546,   671,    22,
     550,   377,    -1,   546,   549,    22,   550,   377,    -1,    84,
      22,   550,   377,    -1,   159,   378,   546,   671,   379,   377,
      -1,   551,   553,   377,    -1,   547,   377,    -1,   180,   550,
     381,   539,   382,    -1,   546,   671,    32,   206,   377,    -1,
     546,   671,    32,   201,   378,   550,   379,   377,    -1,   546,
     671,    32,   146,   378,   550,   379,   377,    -1,   546,   671,
      32,   147,   378,   550,   379,   377,    -1,   546,   671,    32,
      90,   378,   550,   379,   377,    -1,   434,   208,    -1,   436,
      -1,    87,   565,    -1,   215,   566,    -1,   216,   570,    -1,
      -1,   559,   558,   377,    -1,   557,   435,   381,   559,   382,
      -1,    -1,   213,   392,    -1,   209,   211,   213,   392,    -1,
     209,   212,   213,   392,    -1,   210,   212,   213,   392,    -1,
     214,   391,    -1,   105,   393,    -1,    -1,   563,   562,   377,
      -1,    -1,   381,   563,   382,    -1,   561,   446,   564,    -1,
     561,   564,    -1,    -1,    30,    19,    -1,   217,    20,    -1,
      -1,   218,   394,    -1,    -1,   215,   393,    -1,   394,   567,
     568,   569,    -1,   141,   208,   219,   469,     3,    -1,   434,
     123,    -1,   572,   435,   381,    -1,   573,   436,   377,    -1,
     573,   218,   121,   391,   377,    -1,   573,   218,   394,   121,
     391,   377,    -1,   573,   216,   394,   395,   121,   391,   377,
      -1,   573,   246,   249,    81,   425,   377,    -1,   573,   246,
     248,   377,    -1,   573,   247,   248,   377,    -1,   573,   220,
      71,   391,   377,    -1,   573,   224,   220,    71,   391,   377,
      -1,   573,   221,   222,    71,   391,   377,    -1,   573,   223,
      71,   391,   377,    -1,   573,    86,   377,    -1,   573,   215,
     377,    -1,   573,   215,   391,   377,    -1,   573,   226,   227,
     228,   377,    -1,   573,   226,   227,   101,   377,    -1,   573,
     256,   257,   228,   377,    -1,   573,   256,   257,   258,   377,
      -1,   573,   256,   257,   259,   377,    -1,   573,   266,    86,
     377,    -1,   573,   266,   267,   377,    -1,   573,   230,   231,
     393,   377,    -1,   573,   268,   231,   393,   377,    -1,   573,
     265,   231,   393,   377,    -1,   573,   254,   255,   393,   377,
      -1,   573,   271,   268,   393,   377,    -1,   573,   229,   239,
     391,   377,    -1,   573,   229,   238,   391,   377,    -1,   573,
     191,   126,   394,   377,    -1,   573,   232,   233,    71,   391,
     377,    -1,   573,    49,   234,    71,   391,   377,    -1,   573,
      49,   235,    71,   391,   383,   391,   377,    -1,   573,   100,
     236,    49,   393,   377,    -1,   573,   155,   144,   260,   393,
     377,    -1,   573,   155,   250,   393,   377,    -1,   573,   253,
     393,   377,    -1,   573,   251,   252,   393,   377,    -1,   573,
     103,    20,   377,    -1,   573,   144,    95,   391,   377,    -1,
     573,   105,   393,   377,    -1,   573,   261,   262,   393,   377,
      -1,   573,   272,   393,   377,    -1,   573,   273,   218,   121,
     377,    -1,   573,   273,   218,   121,   391,   377,    -1,   573,
     265,    77,   440,   377,    -1,   573,   269,   270,   393,   377,
      -1,   573,   208,   393,   377,    -1,   434,   274,    -1,   574,
     435,   381,    -1,   575,   576,   377,    -1,   436,    -1,   280,
     393,    -1,   281,    80,   393,    -1,   317,   393,    -1,   317,
     393,    95,   391,    -1,   282,   391,    -1,   578,    -1,   275,
     425,    -1,   577,   381,   579,   382,    -1,    -1,   579,   580,
     377,    -1,   281,   393,    -1,   319,    -1,   143,   393,    -1,
     229,   319,   393,    -1,   229,   283,   391,    -1,   229,   284,
     391,    -1,   281,   283,   391,    -1,   320,   393,    -1,   320,
     321,   391,    -1,    -1,   305,   581,   381,   592,   382,    -1,
      -1,   315,   582,   381,   592,   382,    -1,   313,   583,    -1,
      87,   603,    -1,   587,    -1,   584,   381,   585,   382,    -1,
     584,    -1,   396,    -1,    -1,   585,   586,   377,    -1,   306,
     393,    -1,   143,   393,    -1,   283,   391,    -1,   590,   600,
     381,   588,   382,    -1,   590,   600,    -1,    -1,   588,   589,
     377,    -1,    -1,   286,   391,    -1,   285,   391,    -1,   287,
     233,   391,    -1,   235,   391,    -1,   289,   391,    -1,   289,
     113,   391,    -1,   300,    91,    -1,   300,   299,    -1,   300,
     302,    -1,   460,    -1,   307,   308,   425,    -1,   283,   391,
      -1,   286,   391,    -1,   304,   391,    -1,   285,   391,    -1,
     235,   391,    -1,   289,   391,    -1,   289,   113,   391,    -1,
     290,   291,    -1,   290,   292,    -1,   290,   293,    -1,   290,
     294,    -1,   290,   295,    -1,   290,   296,    -1,   290,   297,
      -1,   290,   298,    -1,   325,   291,   393,    -1,   296,   326,
     393,    -1,   287,   233,   391,    -1,   288,   391,    -1,   301,
     293,   393,    -1,   281,   393,    -1,    64,   308,   393,    -1,
     317,   318,   391,    -1,   151,   381,   596,   382,    -1,   300,
      91,    -1,   300,   299,    -1,   300,   302,    -1,   211,   310,
     311,    -1,   211,   310,   312,    -1,   211,   310,   391,    -1,
     212,   449,    -1,   212,   288,   391,    -1,   269,   270,   393,
      -1,   269,   270,   212,   309,    -1,   208,   393,    -1,   460,
      -1,    -1,   592,   593,    -1,   594,   595,   377,    -1,   396,
      -1,    -1,   306,    -1,   314,   391,    -1,    -1,   596,   598,
      -1,    -1,   303,    -1,    18,   597,   377,    -1,    -1,    -1,
     324,   391,    -1,    -1,   601,   591,   377,    -1,    -1,   381,
     601,   382,    -1,   599,   446,   600,   602,    -1,    20,    -1,
      -1,   141,   274,   469,     3,    -1,   141,   274,   151,   469,
     604,     3,    -1,   141,   274,    87,   469,   604,     3,    -1,
     141,   274,   327,   469,   604,     3,    -1,   141,   274,   327,
      43,   469,   604,     3,    -1,   141,   274,   328,   469,   604,
       3,    -1,   141,   274,   328,    43,   469,   604,     3,    -1,
     141,   274,   316,   613,     3,    -1,    -1,   613,   322,    -1,
     613,   275,   425,    -1,   613,   308,    -1,   613,   290,    15,
      -1,   613,   323,   425,    -1,   613,   228,    -1,   613,    80,
     425,    -1,   613,    19,    -1,   434,   329,    -1,   614,   435,
     381,    -1,   615,   436,   377,    -1,   615,   330,    77,    19,
     377,    -1,   615,   331,   332,   377,    -1,   615,   331,   333,
     377,    -1,   434,   334,    -1,   436,    -1,    87,   629,    -1,
     167,   635,    -1,    -1,   351,   618,   641,    -1,    -1,   352,
     619,   647,    -1,   355,   396,    -1,    -1,   620,   617,   377,
      -1,   616,   435,   381,   620,   382,    -1,    -1,   209,   335,
     213,   391,    -1,   119,   335,   213,   391,    -1,   209,   233,
     391,    -1,   336,   393,    -1,   337,   338,   393,    -1,   308,
     339,   391,    -1,   340,    71,   391,    -1,   341,   342,   391,
      -1,   343,   227,    95,   391,    -1,   229,   347,   391,   649,
      -1,   167,   635,    -1,    -1,   351,   624,   641,    -1,    -1,
     352,   625,   647,    -1,   351,   218,   393,    -1,   352,   218,
     393,    -1,    -1,    -1,   627,   623,   377,    -1,    -1,   381,
     627,   382,    -1,   622,   446,   628,   626,    -1,   396,    -1,
     348,   393,    -1,   349,   393,    -1,   350,   393,    -1,   344,
     347,   391,   649,    -1,   345,   347,   391,   649,    -1,    -1,
      -1,   633,   631,   377,    -1,    -1,   381,   633,   382,    -1,
     630,   634,   632,    -1,   394,    -1,    -1,    -1,   353,   636,
      -1,   347,   648,    -1,    -1,    -1,   640,   638,   377,    -1,
     636,    -1,   381,   637,   640,   382,   639,    -1,    20,    -1,
      -1,    -1,   354,   642,    -1,   347,   648,    -1,    -1,    -1,
     646,   644,   377,    -1,   642,    -1,   381,   643,   646,   382,
     645,    -1,   391,    -1,   346,   391,    -1,    -1,   356,   393,
      -1,   434,   357,    -1,   650,   435,   381,    -1,   651,   436,
     377,    -1,   651,   358,   391,   377,    -1,   651,   127,   391,
     377,    -1,   651,   359,   391,   377,    -1,   651,   360,    71,
     391,   377,    -1,   651,    65,    71,   391,   377,    -1,   651,
     300,   652,   377,    -1,   651,   460,   377,    -1,   651,   367,
     369,   377,    -1,   651,   367,   216,   377,    -1,   651,   367,
     368,   377,    -1,   651,    87,   658,   377,    -1,   365,    -1,
     366,    -1,    91,    -1,   291,    -1,   361,    -1,   362,    -1,
     363,    -1,   364,    -1,    -1,   231,   391,    -1,   331,   653,
      -1,   212,   449,    -1,   212,   288,   391,    -1,   269,   270,
     393,    -1,   269,   270,   212,   309,    -1,    -1,   655,   654,
     377,    -1,    -1,   381,   655,   382,    -1,    -1,   657,   446,
     656,    -1,   434,   372,    -1,   659,   435,   381,    -1,   660,
     436,   377,    -1,   660,    64,   308,   393,   377,    -1,   660,
     265,    77,   440,   377,    -1,   660,   664,   377,    -1,   144,
     396,    -1,   225,   394,   395,    -1,   662,   318,   391,    -1,
     662,    -1,   663,   662,    -1,   661,   225,   394,   395,    -1,
     661,   225,    20,    -1,   661,   374,   663,    -1,   661,   267,
     394,    -1,   661,   258,    -1,   661,   162,    -1,   661,   375,
      -1,   661,   376,    -1,   661,   373,    -1,   141,   372,   469,
       3,    -1,   377,    -1,   390,    -1,   401,    -1,   407,    -1,
     410,    -1,   424,    -1,   426,    -1,   430,    -1,   433,    -1,
     668,    -1,   441,    -1,   506,    -1,   508,    -1,   518,    -1,
     411,    -1,   412,    -1,   413,    -1,   414,    -1,   415,    -1,
     416,    -1,   465,    -1,   466,    -1,   467,    -1,   468,    -1,
     470,    -1,   471,    -1,   472,    -1,   475,    -1,   478,    -1,
     481,    -1,   482,    -1,   483,    -1,   484,    -1,   485,    -1,
     486,    -1,   487,    -1,   488,    -1,   489,    -1,   490,    -1,
     491,    -1,   492,    -1,   495,    -1,   496,    -1,   497,    -1,
     498,    -1,   499,    -1,   500,    -1,   501,    -1,   502,    -1,
     503,    -1,   571,    -1,   605,    -1,   606,    -1,   607,    -1,
     608,    -1,   609,    -1,   610,    -1,   611,    -1,   612,    -1,
     665,    -1,   669,   382,    -1,   670,   382,    -1,   451,   382,
      -1,   560,    -1,   573,   382,    -1,   575,   382,    -1,   615,
     382,    -1,   621,    -1,   651,   382,    -1,   660,   382,    -1,
     419,   435,   381,    -1,   669,   436,   377,    -1,   669,   420,
     377,    -1,   669,   423,   377,    -1,   421,   435,   381,    -1,
     670,   436,   377,    -1,   670,   422,   377,    -1,    75,    -1,
      76,    -1,    78,    -1,    79,    -1,   138,    -1,     5,    -1,
     240,    -1,   237,    -1,   241,    -1,   239,    -1,   238,    -1,
     242,    -1,   243,    -1,   244,    -1,   263,    -1,   264,    -1,
     245,    -1,   276,    -1,   277,    -1,   278,    -1,   279,    -1,
     370,    -1,   371,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   708,   708,   709,   712,   714,   722,   731,   732,   733,
     740,   741,   742,   750,   751,   752,   753,   754,   755,   761,
     762,   769,   770,   774,   781,   782,   786,   790,   797,   805,
     806,   812,   821,   822,   826,   831,   832,   836,   837,   841,
     842,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     860,   861,   870,   871,   872,   873,   876,   877,   878,   879,
     880,   881,   885,   892,   895,   902,   905,   908,   911,   915,
     916,   920,   921,   922,   930,   935,   936,   940,   947,   953,
     958,   962,   976,   990,   991,   995,   996,   997,  1008,  1010,
    1012,  1016,  1017,  1018,  1019,  1026,  1027,  1031,  1039,  1043,
    1045,  1051,  1052,  1059,  1060,  1064,  1070,  1074,  1084,  1086,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1105,  1106,  1107,  1108,  1112,  1113,  1114,  1115,
    1116,  1120,  1126,  1130,  1138,  1139,  1147,  1155,  1156,  1157,
    1161,  1162,  1166,  1171,  1172,  1175,  1183,  1187,  1188,  1194,
    1201,  1202,  1203,  1207,  1215,  1221,  1222,  1223,  1227,  1228,
    1232,  1233,  1234,  1235,  1236,  1237,  1243,  1244,  1245,  1249,
    1250,  1254,  1255,  1261,  1262,  1265,  1267,  1271,  1272,  1276,
    1294,  1295,  1296,  1297,  1298,  1299,  1307,  1310,  1313,  1316,
    1320,  1321,  1324,  1327,  1331,  1335,  1340,  1346,  1353,  1358,
    1363,  1368,  1372,  1376,  1380,  1390,  1398,  1402,  1409,  1410,
    1415,  1419,  1426,  1433,  1437,  1445,  1446,  1447,  1452,  1456,
    1459,  1460,  1461,  1462,  1463,  1464,  1465,  1470,  1475,  1483,
    1490,  1497,  1505,  1507,  1509,  1511,  1513,  1515,  1517,  1520,
    1524,  1530,  1531,  1532,  1536,  1537,  1543,  1545,  1547,  1549,
    1551,  1553,  1557,  1561,  1564,  1568,  1569,  1570,  1574,  1575,
    1576,  1584,  1584,  1594,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1631,  1642,  1643,
    1650,  1651,  1658,  1667,  1671,  1675,  1699,  1700,  1704,  1717,
    1717,  1733,  1734,  1737,  1738,  1742,  1745,  1754,  1767,  1768,
    1769,  1770,  1774,  1775,  1776,  1777,  1778,  1782,  1785,  1786,
    1787,  1791,  1794,  1803,  1806,  1807,  1808,  1809,  1813,  1814,
    1815,  1819,  1820,  1821,  1822,  1826,  1827,  1828,  1829,  1833,
    1834,  1838,  1839,  1843,  1850,  1851,  1852,  1853,  1860,  1861,
    1864,  1865,  1872,  1884,  1885,  1889,  1890,  1894,  1895,  1896,
    1897,  1898,  1902,  1903,  1904,  1908,  1909,  1910,  1911,  1912,
    1913,  1914,  1915,  1916,  1917,  1918,  1922,  1923,  1933,  1937,
    1960,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,
    1983,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2004,  2005,  2006,
    2008,  2010,  2012,  2014,  2015,  2016,  2017,  2018,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2036,  2037,  2042,  2065,  2066,
    2067,  2068,  2069,  2070,  2074,  2077,  2078,  2079,  2087,  2094,
    2103,  2104,  2108,  2114,  2124,  2133,  2139,  2144,  2151,  2156,
    2162,  2163,  2164,  2172,  2173,  2174,  2175,  2176,  2182,  2194,
    2195,  2196,  2197,  2200,  2202,  2206,  2210,  2221,  2222,  2223,
    2224,  2225,  2226,  2229,  2231,  2234,  2236,  2239,  2242,  2247,
    2248,  2249,  2253,  2254,  2258,  2259,  2262,  2280,  2286,  2308,
    2309,  2310,  2311,  2312,  2322,  2323,  2324,  2325,  2326,  2327,
    2328,  2329,  2330,  2331,  2332,  2333,  2334,  2335,  2336,  2337,
    2338,  2339,  2340,  2341,  2342,  2343,  2344,  2345,  2346,  2347,
    2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,  2356,  2361,
    2362,  2363,  2364,  2365,  2366,  2367,  2368,  2379,  2389,  2390,
    2394,  2395,  2396,  2397,  2398,  2399,  2400,  2403,  2418,  2421,
    2423,  2427,  2428,  2429,  2430,  2431,  2432,  2433,  2434,  2435,
    2436,  2436,  2437,  2437,  2438,  2439,  2440,  2444,  2445,  2449,
    2457,  2459,  2463,  2464,  2465,  2469,  2470,  2473,  2475,  2478,
    2479,  2480,  2481,  2482,  2483,  2484,  2485,  2486,  2487,  2488,
    2491,  2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,  2521,
    2522,  2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,
    2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,  2541,
    2542,  2543,  2544,  2545,  2546,  2547,  2548,  2551,  2553,  2556,
    2558,  2567,  2569,  2570,  2573,  2575,  2579,  2580,  2583,  2593,
    2616,  2618,  2621,  2623,  2626,  2628,  2632,  2636,  2637,  2642,
    2645,  2648,  2653,  2656,  2661,  2664,  2668,  2672,  2675,  2676,
    2677,  2678,  2679,  2680,  2681,  2682,  2688,  2695,  2696,  2697,
    2702,  2703,  2709,  2719,  2720,  2721,  2722,  2722,  2723,  2723,
    2724,  2731,  2733,  2737,  2741,  2758,  2759,  2760,  2761,  2762,
    2763,  2764,  2765,  2766,  2767,  2772,  2773,  2773,  2774,  2774,
    2775,  2776,  2780,  2798,  2800,  2803,  2805,  2809,  2812,  2825,
    2826,  2827,  2828,  2833,  2841,  2849,  2851,  2854,  2856,  2860,
    2864,  2874,  2879,  2880,  2881,  2885,  2897,  2899,  2903,  2904,
    2908,  2921,  2926,  2927,  2928,  2932,  2944,  2946,  2950,  2951,
    2956,  2957,  2961,  2962,  2968,  2975,  2976,  2977,  2978,  2979,
    2980,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2991,  2992,
    2993,  2998,  2999,  3000,  3001,  3002,  3005,  3006,  3007,  3008,
    3009,  3010,  3011,  3014,  3016,  3019,  3021,  3025,  3037,  3044,
    3051,  3052,  3053,  3054,  3055,  3058,  3067,  3075,  3082,  3083,
    3087,  3092,  3098,  3101,  3106,  3107,  3108,  3109,  3110,  3113,
    3120,  3120,  3120,  3120,  3120,  3120,  3120,  3120,  3120,  3120,
    3120,  3120,  3120,  3120,  3121,  3121,  3121,  3121,  3121,  3121,
    3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,
    3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,
    3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,
    3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,  3121,
    3122,  3122,  3122,  3122,  3122,  3122,  3122,  3122,  3122,  3122,
    3123,  3123,  3123,  3123,  3124,  3124,  3124,  3125,  3125,  3125,
    3125,  3125,  3126,  3126,  3127,  3128,  3129,  3130,  3131,  3132,
    3133,  3134,  3135,  3136,  3137,  3137,  3137,  3137,  3137,  3137
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "LOG", "SYSLOG", "ALL",
  "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL",
  "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT", "LONG",
  "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT", "CONFIGURE",
  "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES",
  "KRT_SOURCE", "KRT_METRIC", "TABLE", "KRT_PREFSRC", "KRT_REALM",
  "ROUTER", "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED",
  "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES",
  "FILTERS", "RECEIVE", "LIMIT", "ACTION", "WARN", "BLOCK", "RESTART",
  "DISABLE", "KEEP", "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO",
  "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS",
  "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE", "ROA", "MAX",
  "FLUSH", "AS", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS", "PORT",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "IF",
  "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN",
  "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE", "CAST",
  "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS", "RESET",
  "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK", "EMPTY", "WHERE",
  "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL", "MULTIPLIER", "MULTIHOP",
  "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD", "CONNECT", "RETRY",
  "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH",
  "METRIC", "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "OSPF", "AREA",
  "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "TYPE", "BROADCAST", "BCAST",
  "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "SIMPLE", "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE",
  "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "ONLY", "BUFFER",
  "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP",
  "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID",
  "INSTANCE", "REAL", "NETMASK", "TOPOLOGY", "STATE", "PIPE", "PEER",
  "MODE", "OPAQUE", "TRANSPARENT", "RADV", "RA", "MANAGED", "OTHER",
  "CONFIG", "MTU", "REACHABLE", "RETRANS", "TIMER", "CURRENT", "VALID",
  "PREFERRED", "MULT", "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS",
  "DNSSL", "NS", "DOMAIN", "TRIGGER", "SENSITIVE", "RIP", "INFINITY",
  "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN", "VERSION1",
  "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC", "RIP_TAG",
  "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "';'",
  "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "definition", "expr", "expr_us", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "tab_sorted", "newtab", "roa_table_start", "roa_table_opts", "roa_table",
  "proto_start", "proto_name", "proto_item", "imexport", "limit_action",
  "limit_spec", "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_init", "iface_patt", "tos",
  "dev_proto_start", "dev_proto", "dev_iface_init", "dev_iface_patt",
  "debug_mask", "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_item", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@5", "$@6", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@7", "$@8", "radv_iface_finish",
  "radv_iface_opts", "radv_iface_opt_list", "radv_iface",
  "radv_prefix_start", "radv_prefix_item", "radv_prefix_finish",
  "radv_prefix_opts", "radv_prefix_opt_list", "radv_prefix",
  "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,    59,    40,    41,
      58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   387,   388,   388,   389,   389,   390,   391,   391,   391,
     392,   392,   392,   393,   393,   393,   393,   393,   393,   394,
     394,   395,   395,   396,   397,   397,   398,   398,   399,   400,
     400,   401,   402,   402,   403,   403,   403,   404,   404,   405,
     405,   406,   406,   406,   406,   406,   406,   406,   406,   406,
     407,   407,   408,   408,   408,   408,   409,   409,   409,   409,
     409,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     417,   418,   418,   418,   419,   420,   420,   420,   420,   421,
     422,   422,   423,   424,   424,   425,   425,   425,   426,   427,
     427,   428,   428,   428,   428,   429,   429,   430,   431,   432,
     432,   433,   433,   434,   434,   435,   435,   435,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   437,   437,   437,   437,   438,   438,   438,   438,
     438,   439,   439,   440,   441,   441,   442,   443,   443,   443,
     444,   444,   445,   446,   446,   447,   448,   449,   449,   450,
     451,   451,   451,   452,   453,   454,   454,   454,   455,   455,
     456,   456,   456,   456,   456,   456,   457,   457,   457,   458,
     458,   459,   459,   460,   460,   461,   461,   462,   462,   463,
     464,   464,   464,   464,   464,   464,   465,   466,   467,   468,
     469,   469,   470,   471,   472,   473,   473,   473,   473,   473,
     473,   473,   473,   473,   473,   473,   473,   473,   474,   474,
     475,   476,   476,   476,   476,   477,   477,   477,   478,   479,
     479,   479,   479,   479,   479,   479,   479,   480,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   493,   493,   494,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   504,   504,   505,   505,
     505,   507,   506,   508,   509,   509,   509,   509,   509,   509,
     509,   509,   509,   509,   509,   509,   509,   510,   511,   511,
     512,   512,   513,   514,   514,   515,   516,   516,   517,   519,
     518,   520,   520,   521,   521,   522,   522,   523,   524,   524,
     524,   524,   525,   525,   525,   525,   525,   526,   527,   527,
     527,   528,   528,   529,   530,   530,   530,   530,   531,   531,
     531,   532,   532,   532,   532,   533,   533,   533,   533,   534,
     534,   535,   535,   536,   537,   537,   537,   537,   538,   538,
     539,   539,   539,   540,   540,   541,   541,   542,   542,   542,
     542,   542,   543,   543,   543,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   545,   545,   546,   547,
     548,   549,   549,   549,   549,   549,   549,   549,   549,   549,
     549,   550,   550,   550,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   550,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   550,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   550,   550,   550,   550,   550,   551,   551,
     551,   551,   551,   551,   552,   553,   553,   553,   554,   554,
     555,   555,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   557,   558,
     558,   558,   558,   559,   559,   560,   561,   562,   562,   562,
     562,   562,   562,   563,   563,   564,   564,   565,   566,   567,
     567,   567,   568,   568,   569,   569,   570,   571,   572,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   574,   575,   575,
     576,   576,   576,   576,   576,   576,   576,   577,   578,   579,
     579,   580,   580,   580,   580,   580,   580,   580,   580,   580,
     581,   580,   582,   580,   580,   580,   580,   583,   583,   584,
     585,   585,   586,   586,   586,   587,   587,   588,   588,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     590,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   592,   592,   593,
     594,   595,   595,   595,   596,   596,   597,   597,   598,   599,
     600,   600,   601,   601,   602,   602,   603,   604,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   613,   613,
     613,   613,   613,   613,   613,   613,   614,   615,   615,   615,
     615,   615,   616,   617,   617,   617,   618,   617,   619,   617,
     617,   620,   620,   621,   622,   623,   623,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   624,   623,   625,   623,
     623,   623,   626,   627,   627,   628,   628,   629,   630,   631,
     631,   631,   631,   631,   632,   633,   633,   634,   634,   635,
     636,   637,   638,   638,   638,   639,   640,   640,   641,   641,
     642,   643,   644,   644,   644,   645,   646,   646,   647,   647,
     648,   648,   649,   649,   650,   651,   651,   651,   651,   651,
     651,   651,   651,   651,   651,   651,   651,   651,   652,   652,
     652,   653,   653,   653,   653,   653,   654,   654,   654,   654,
     654,   654,   654,   655,   655,   656,   656,   657,   658,   659,
     660,   660,   660,   660,   660,   661,   662,   662,   663,   663,
     664,   664,   664,   664,   664,   664,   664,   664,   664,   665,
     666,   666,   666,   666,   666,   666,   666,   666,   666,   666,
     666,   666,   666,   666,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   667,   667,   667,   667,   667,   667,   667,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     669,   669,   669,   669,   670,   670,   670,   671,   671,   671,
     671,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   671,   671,   671,   671,   671,   671,   671
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       0,     4,     2,     0,     1,     2,     1,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     3,     1,     1,     1,     1,     2,     4,     3,     3,
       3,     3,     3,     4,     5,     3,     3,     4,     2,     0,
       1,     0,     1,     2,     2,     2,     3,     2,     3,     2,
       3,     3,     3,     4,     5,     1,     1,     1,     4,     0,
       2,     2,     2,     1,     1,     0,     1,     3,     3,     0,
       8,     1,     4,     1,     1,     0,     1,     3,     0,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     4,     2,
       3,     2,     2,     1,     1,     1,     0,     2,     2,     2,
       2,     2,     1,     1,     3,     3,     0,     1,     1,     2,
       0,     1,     3,     1,     3,     0,     2,     2,     2,     2,
       3,     3,     3,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     3,     3,     4,     5,
       1,     0,     3,     4,     4,     0,     2,     3,     3,     3,
       2,     2,     2,     2,     3,     3,     2,     2,     1,     1,
       4,     0,     3,     3,     3,     0,     1,     1,     4,     0,
       2,     2,     2,     2,     2,     2,     2,     0,     2,     9,
       9,     4,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     1,     1,     3,     0,     1,     3,     3,     3,     3,
       4,     4,     4,     4,     2,     1,     1,     1,     1,     0,
       1,     0,     4,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     0,     3,
       1,     3,     1,     1,     1,     2,     3,     2,     4,     0,
       5,     0,     1,     1,     2,     1,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     5,    11,     1,     1,     1,     2,     1,     7,     9,
       7,     1,     1,     1,     3,     1,     1,     1,     3,     1,
       3,     1,     3,     3,     1,     2,     2,     6,     1,     3,
       0,     4,     3,     1,     3,     3,     3,     2,     2,     2,
       2,     0,     2,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     1,     5,     7,     0,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     4,     1,     1,     1,
       1,     2,     2,     3,     3,     6,     3,     3,     3,     3,
       5,     6,     6,     6,     6,     4,     8,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     8,     2,     1,
       2,     2,     2,     0,     3,     5,     0,     2,     4,     4,
       4,     2,     2,     0,     3,     0,     3,     3,     2,     0,
       2,     2,     0,     2,     0,     2,     4,     5,     2,     3,
       3,     5,     6,     7,     6,     4,     4,     5,     6,     6,
       5,     3,     3,     4,     5,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     8,     6,     6,     5,     4,     5,     4,     5,     4,
       5,     4,     5,     6,     5,     5,     4,     2,     3,     3,
       1,     2,     3,     2,     4,     2,     1,     2,     4,     0,
       3,     2,     1,     2,     3,     3,     3,     3,     2,     3,
       0,     5,     0,     5,     2,     2,     1,     4,     1,     1,
       0,     3,     2,     2,     2,     5,     2,     0,     3,     0,
       2,     2,     3,     2,     2,     3,     2,     2,     2,     1,
       3,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     2,
       3,     2,     3,     3,     4,     2,     2,     2,     3,     3,
       3,     2,     3,     3,     4,     2,     1,     0,     2,     3,
       1,     0,     1,     2,     0,     2,     0,     1,     3,     0,
       0,     2,     0,     3,     0,     3,     4,     1,     0,     4,
       6,     6,     6,     7,     6,     7,     5,     0,     2,     3,
       2,     3,     3,     2,     3,     2,     2,     3,     3,     5,
       4,     4,     2,     1,     2,     2,     0,     3,     0,     3,
       2,     0,     3,     5,     0,     4,     4,     3,     2,     3,
       3,     3,     3,     4,     4,     2,     0,     3,     0,     3,
       3,     3,     0,     0,     3,     0,     3,     4,     1,     2,
       2,     2,     4,     4,     0,     0,     3,     0,     3,     3,
       1,     0,     0,     2,     2,     0,     0,     3,     1,     5,
       1,     0,     0,     2,     2,     0,     0,     3,     1,     5,
       1,     2,     0,     2,     2,     3,     3,     4,     4,     4,
       5,     5,     4,     3,     4,     4,     4,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     2,     2,
       3,     3,     4,     0,     3,     0,     3,     0,     3,     2,
       3,     3,     5,     5,     3,     2,     3,     3,     1,     2,
       4,     3,     3,     3,     2,     2,     2,     2,     2,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     1,     2,     2,     2,     1,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    69,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   368,     0,     0,
     804,   805,   806,   807,   808,   809,   810,   811,   812,   813,
     814,   815,   816,   817,   818,   819,   820,   821,   822,   823,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,   836,   837,   838,   839,   840,   841,   842,   843,
     844,   845,   846,   847,   848,   849,     3,     1,     2,     0,
       0,     0,     0,     0,     0,   103,   104,     0,     0,     0,
       0,   368,     0,   790,   791,   792,   793,   794,   105,   105,
     795,   796,   797,   101,   798,     0,   800,   105,   108,   801,
     802,   803,   105,   853,   105,   108,   105,   108,   105,   108,
     105,   857,   105,   108,   105,   108,     5,   799,   108,   108,
     255,   257,   256,     0,    70,    69,     0,     0,    69,    71,
      68,     0,     0,   227,     0,     0,     0,     0,   254,   259,
       0,   211,     0,     0,   195,   219,     0,   191,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   351,   355,
     364,   361,   297,   370,   358,     0,     0,   354,   368,   400,
       0,     0,     0,   356,   357,     0,     0,     0,   368,     0,
     359,   360,   365,   398,   399,     0,   397,     0,   242,   241,
       0,   244,     0,     0,    34,    33,    36,     0,     0,     0,
      55,    54,    53,    52,     0,     0,    95,     0,   261,     0,
      89,     0,     0,   263,   289,   106,     0,     0,    99,    74,
      79,   149,   478,   448,   527,   656,   662,   734,   769,     0,
       0,     0,     0,     0,    18,   153,     0,     0,     0,     0,
       0,   852,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    18,
       0,     0,     0,     0,     0,     0,     0,     0,    18,     0,
     854,     0,     0,     0,    18,     0,     0,    18,   855,   530,
       0,     0,   536,     0,     0,     0,   856,     0,     0,     0,
       0,   767,     0,     0,     0,     0,     0,     0,     0,     0,
     858,     0,     0,   174,   178,     0,     0,     0,     0,   859,
       0,     0,     0,     0,    18,     0,    18,     0,   850,     0,
       0,     0,     0,    30,   851,     0,     0,   156,   155,     0,
       0,    71,    65,    66,     0,    72,     0,   248,   246,     0,
       0,     0,     0,   249,   167,   166,     0,     0,   258,   260,
     259,     0,   192,     0,   215,   187,   186,     0,     0,   191,
     190,   191,   191,   647,   191,   191,     0,     0,    19,    20,
       0,     0,     0,   237,   238,   234,   232,   233,   235,   236,
     351,   370,   351,   368,   351,   351,     0,   343,     0,   368,
       0,     0,     0,   354,   354,     0,   395,   368,   368,   368,
     368,   368,     0,   314,   315,     0,   317,     0,     0,     7,
     301,   299,     9,   368,   298,   300,   323,   321,   322,   329,
       0,   334,   338,     0,   872,   867,   868,   869,   870,   371,
     871,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     874,   877,   876,   873,   875,   878,   879,   880,   883,   881,
     882,   884,   885,   886,   887,   888,   889,   401,   402,   239,
     368,   368,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   368,   368,     0,    41,    42,    43,    44,    45,    46,
      47,    48,    49,     0,    39,   245,     0,   247,   368,     0,
      35,    37,     0,     0,   134,   368,   135,    56,     0,     0,
      62,    96,    97,    85,    86,    87,   145,     0,   278,    98,
       0,    51,     0,     0,     0,   860,   864,     0,   150,   111,
     133,   119,     0,   109,    14,    16,    15,    17,    13,   110,
     136,   124,   278,   125,     0,     0,   368,   113,   123,     0,
     114,     0,   121,   112,   151,   152,   453,   479,     0,     0,
     491,     0,     0,     0,     0,     0,    18,     0,     0,   492,
       0,    21,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,     0,     0,     0,     0,    18,     0,    18,     0,
      18,     0,    18,     0,     0,    18,    18,    18,     0,     0,
     480,   528,   537,   531,    18,   535,   533,   529,   539,   657,
       0,     0,     0,   658,   671,   735,     0,   136,     0,   179,
       0,   175,   750,   748,   749,     0,     0,     0,     0,     0,
       0,     0,   736,   743,   180,   770,    18,   775,     0,   771,
     785,     0,   784,     0,   788,     0,   786,   787,   774,     0,
      75,     0,    77,    18,   862,   863,   861,     0,    29,     0,
     866,   865,   161,   160,   162,   164,   165,   163,     0,   158,
     252,     0,    67,    73,    63,   228,   231,   250,   251,   171,
     172,     0,   169,   253,     0,   188,   193,   210,     0,   217,
       0,   216,     0,   194,   201,     0,     0,   209,   278,   203,
     202,   206,   207,     0,   208,   196,     0,   200,   218,   226,
     220,   223,   224,   222,   225,   221,     0,   638,   638,     0,
     191,   638,   191,   638,   639,   789,     0,     0,    23,     0,
       0,   347,   348,     0,   349,   350,   345,   333,   428,   431,
       0,   408,     0,   409,   352,   353,   346,     0,     0,     0,
       0,     0,     0,   316,   368,   381,   368,   310,   308,     0,
       0,   307,     0,     0,   362,   335,   336,     0,     0,   363,
     393,   391,   389,   386,   387,   388,   390,   392,   394,   382,
     383,   384,   385,   403,     0,   404,   406,   407,   243,     0,
     240,     0,    32,     0,    31,     0,     0,    58,    59,    60,
      61,   136,     0,    83,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,     0,     0,     0,   262,
     282,    93,    94,     0,     0,    88,    90,    50,     0,   278,
     107,     0,   102,   120,   140,   143,   154,   283,   284,   122,
     132,   126,   116,    18,   285,   117,   115,   108,     0,     0,
      18,   517,   519,     0,    18,     0,     0,   526,   493,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   485,     0,   486,     0,   515,     0,     0,
       0,     0,     0,     0,     0,   499,   500,     0,     0,     0,
     521,     0,   532,     0,     0,     0,   660,   661,   108,     0,
     765,   747,   738,     0,     0,   742,   737,   739,     0,   745,
     746,   744,     0,     0,     0,     0,     0,     0,   781,    21,
     783,     0,   778,   782,    82,    76,    78,    80,    25,    24,
      81,   157,     0,    64,   168,     0,   189,   214,   213,   212,
     198,   205,   199,   197,   204,   477,   637,     0,     0,   646,
     655,     0,   653,     0,     0,   650,   648,     0,   638,     0,
     638,     0,    26,    27,     0,     0,   344,   368,   417,     0,
     368,   368,   368,   396,   368,   415,   368,     0,     0,   368,
     368,   368,     8,   297,   324,   330,     0,     0,   339,   368,
      40,     6,    38,    57,   146,    84,   277,   276,   278,   368,
      91,    92,   287,   280,     0,   290,     0,   141,     0,   136,
       0,   131,   118,   456,   456,     0,   455,   449,     0,     0,
       0,     0,   518,     0,   514,   508,    22,     0,   481,     0,
     487,     0,   490,     0,   495,   494,   507,   506,   501,     0,
       0,   516,   504,   496,   497,   498,   520,   524,   503,   502,
     525,   505,   522,     0,   534,   629,    18,     0,    18,   550,
       0,     0,   552,   542,    18,   538,     0,   556,   630,   659,
     674,     0,   666,   668,     0,   673,   663,     0,   741,   763,
     768,   173,   175,   740,     0,     0,     0,     0,     0,   177,
     772,   773,   780,    21,     0,   779,   159,   170,   641,   640,
     654,   649,   651,   652,     0,   642,     0,   644,     0,     0,
     429,   410,     0,     0,     0,     0,     0,   368,   366,   309,
     307,     0,     0,   313,     0,     0,   279,     0,   421,     0,
     422,   423,     0,   368,   419,   420,   418,   368,   368,     0,
     368,     0,     0,   368,   293,     0,   286,     0,   137,   138,
     142,   144,   127,   128,   129,   130,   136,   450,   465,   451,
     469,   452,   454,   510,     0,   512,   513,     0,   482,   489,
     488,   509,   484,   523,   136,   555,   543,     0,     0,    18,
       0,   541,     0,     0,   559,   554,   558,     0,     0,   548,
     540,     0,   566,   136,   664,   698,   707,   665,     0,     0,
     670,   672,   756,   176,   180,    28,     0,     0,     0,     0,
     776,   777,   643,   645,   227,   227,   414,   412,   413,   411,
     368,     0,   311,   368,     0,   405,   368,   368,   368,   368,
       0,     0,     0,   288,   294,     0,     0,   441,   424,   426,
       0,   281,     0,   139,   465,   463,   468,     0,     0,   472,
       0,   483,   630,   545,   546,   544,   547,   617,   580,   560,
     617,   549,   631,   567,   695,   705,   704,   711,   710,   718,
     667,   720,   721,   728,   669,     0,     0,     0,     0,   766,
       0,   185,   180,   180,   180,   180,     0,     0,     0,   367,
       0,     0,     0,   337,     0,     0,     0,     0,   435,   368,
     340,   368,   368,     0,   368,   440,     0,   467,     0,   470,
     471,     0,   474,   511,   634,     0,     0,     0,   569,   693,
     692,     0,   709,   716,   726,     0,     0,     0,   759,   757,
      18,   751,   752,   753,   754,   755,   758,   764,   181,   182,
     183,   184,   229,   230,   416,   368,   320,   368,   318,   434,
     369,   438,     0,   368,   432,   295,     0,     0,     0,     0,
       0,     0,     0,     0,   427,     0,    18,     0,     0,     0,
       0,   466,     0,   473,    18,   476,   632,   636,   551,   620,
     618,   621,    18,     0,    18,   557,     0,   553,     0,     0,
       0,     0,     0,     0,   565,   579,     0,     0,   697,     0,
       0,    18,    18,    18,   708,     0,   712,   722,   147,   148,
     760,     0,   761,     0,     0,     0,     0,   368,   368,   302,
     306,   304,   368,   442,   305,   327,   325,   326,   331,     0,
     437,   436,   368,   368,   368,   368,   443,   100,   462,     0,
       0,     0,     0,   457,   461,   464,   475,     0,   622,     0,
       0,   563,   564,   562,   561,   573,   571,   570,     0,     0,
     574,   576,   577,   578,   568,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,   686,   688,   696,     0,     0,
       0,   699,   700,   701,   706,     0,     0,   715,     0,     0,
       0,   725,     0,   762,   368,   319,   439,   296,   433,   342,
     307,     0,   368,     0,     0,     0,     0,     0,     0,     0,
       0,    10,    11,    12,     0,     0,    18,     0,     0,     0,
       0,    18,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   635,   616,     0,   623,   619,
     572,   575,     0,   685,     0,     0,     0,     0,   678,    18,
       0,     0,     0,    18,     0,    18,     0,   694,   732,   732,
       0,   730,   714,   713,   719,   717,   724,   723,   729,   727,
       0,   303,   368,   328,   341,   332,     0,     0,     0,     0,
     458,   459,   460,    18,   624,   615,     0,     0,   611,   585,
      18,   601,   581,   584,   582,     0,   599,     0,   586,   588,
     589,   590,   591,   592,   593,   594,   595,    18,   605,   606,
     607,    18,   583,     0,    18,   633,     0,   677,     0,   732,
     680,   679,   681,   682,     0,   690,   687,   691,   689,    18,
     702,   703,   731,   312,     0,   447,   445,   446,   444,   602,
       0,   608,   609,   610,   612,     0,   613,   598,   587,   597,
     600,   603,   596,   676,   675,   684,   683,   733,   626,   604,
     625,   614,   627,     0,   628
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    84,   538,  1443,   539,   380,   860,   929,
     930,   728,  1206,   659,    85,   500,   197,   503,   493,   494,
      86,   204,   205,    87,    20,    21,    22,    23,    24,    25,
     129,   346,    88,   329,    89,   335,   330,    90,   517,    91,
     520,   826,   512,    92,    93,   527,    94,    95,   216,   242,
     547,  1011,   842,   531,    96,   834,  1150,  1008,   835,   836,
     801,   802,  1328,    97,    98,   540,   243,   340,   668,   669,
     357,   681,   682,   312,   903,   313,   314,   915,    26,    27,
      28,    29,   376,    30,    31,    32,   367,   706,    33,   364,
     692,    34,   368,   350,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,   191,   496,    47,    48,
      49,    50,    51,    52,    53,    54,    55,   123,   361,    99,
     518,   100,   816,   817,   818,  1004,   838,   839,   548,   829,
     820,   101,   523,  1139,  1140,  1354,   180,   426,  1425,   758,
     759,   427,  1122,   760,   428,   429,  1428,   430,  1429,   181,
     432,   433,  1356,   395,   182,   396,   405,   183,   184,   185,
    1142,   186,   467,  1120,  1143,  1239,  1240,   739,   740,  1144,
     102,  1018,   847,   103,  1156,  1372,  1308,  1246,  1157,  1159,
    1249,  1312,  1375,  1161,    56,   104,   105,   106,   107,   290,
     291,   292,   894,  1066,  1182,  1187,  1185,  1186,  1316,  1386,
    1067,  1318,  1396,  1068,  1537,  1315,  1380,  1381,  1450,  1640,
    1663,  1660,  1174,  1192,  1447,  1377,  1175,   947,    57,    58,
      59,    60,    61,    62,    63,    64,   719,   108,   109,   110,
    1077,  1198,  1199,   898,   111,  1193,  1478,  1554,  1556,  1398,
    1397,  1320,  1194,  1196,  1405,  1322,  1321,  1266,  1197,  1269,
    1323,  1488,  1564,  1406,  1270,  1273,  1324,  1492,  1568,  1407,
    1274,  1562,  1630,   112,   113,   625,  1336,  1280,  1202,  1080,
     617,   618,   114,   115,   321,   922,   923,   322,    65,   116,
      66,   117,   118,   119,   468
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1430
static const yytype_int16 yypact[] =
{
      56,  2587,   240,   556,   640,  1022,   342,   640,   640,   250,
     674,   640,   371,   702,   271,   282,   904,  1473,    62,   640,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,   391,
     523,    83,   547,   395,   338, -1430, -1430,   432,   405,   364,
     210,  1473,   494, -1430, -1430, -1430, -1430, -1430,   498,   498,
   -1430, -1430, -1430,   142, -1430,   609, -1430,   498,  2443, -1430,
   -1430, -1430,   498, -1430,   498,  2213,   498,  2028,   498,  1303,
     498, -1430,   498,  2015,   498,  2328, -1430, -1430,  2091,  2427,
   -1430, -1430, -1430,    63, -1430,   507,   541,   570,   507,   475,
   -1430,   596,   605,   508,   640,   640,   637,   134, -1430,   714,
     106, -1430,   642,   666, -1430, -1430,   477,   297,   680,   113,
     113,   705,   712,   717,   735,   745,   752,   763,    31, -1430,
   -1430, -1430,   744,   411, -1430,   577,    84,    13,  1473, -1430,
     441,   444,   450, -1430, -1430,   457,   464,   480,   814,    39,
   -1430, -1430, -1430, -1430, -1430,  2007, -1430,  2666, -1430, -1430,
    1721,   845,   864,   848, -1430,   813, -1430,   -16,    63,    58,
   -1430, -1430, -1430, -1430,   427,   499,   748,   489, -1430,   863,
   -1430,   515,   134,  2735, -1430,   780,   513,   516, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,   522,
      63,   890,   830,    58,    57, -1430,   795,   537,   818,   906,
     134, -1430,   552,   554,   553,   568,   -62,   560,   720,   938,
      57,   868,   -32,   839,    57,   190,   113,   234,   900,   761,
     908,   767,   762,    73,   760,   768,   487,   746,   753,    57,
     749,   750,   741,   -12,   -25,   775,   739,   742,    57,   799,
   -1430,   641,   643,   710,    57,   941,    58,    57, -1430, -1430,
     648,   645, -1430,   650,   958,   409, -1430,   661,   658,   660,
     975, -1430,  1028,    58,   668,   -52,    58,    58,   979,   -66,
   -1430,   675,   681, -1430,   676,   678,   754,   113,   984, -1430,
     688,   898,   696,  1004,    57,  1012,    57,  1014, -1430,   719,
     721,   722,  1042,  1095, -1430,   740,   747, -1430, -1430,  1065,
    1115,   475, -1430, -1430,  1119,    58,  1124, -1430, -1430,  1106,
    1126,  1133,  1134, -1430, -1430, -1430,   335,  1135, -1430, -1430,
     757,  1137, -1430,  1139,   449, -1430, -1430,  2499,  1587,   680,
   -1430,   680,   680, -1430,   248,   459,  1140,  1149, -1430, -1430,
      49,  1034,  1040, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
      31, -1430,    31,  1473,    31,    31,  1148, -1430,  1151,   846,
    1141,   957,  1142,    13,    13,  1145,  1144,  1473,  1473,  1473,
    1473,  1473,  1152, -1430, -1430,  1167, -1430,   800,    92, -1430,
   -1430, -1430, -1430,   734, -1430, -1430,  1180, -1430, -1430, -1430,
     125,    69, -1430,   188, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
    1473,  1473,  1473,  1473,  1473,  1473,  1473,  1473,  1473,  1473,
    1473,  1473,  1473,   593, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430,   524, -1430, -1430,  1186, -1430,  1473,  1170,
   -1430, -1430,  1721,   816, -1430,  1473, -1430,    58,   751,   886,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430,   817,  2604, -1430,
     161, -1430,   819,   822,  1172, -1430, -1430,   -28, -1430, -1430,
   -1430, -1430,   710, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430,  1888, -1430,    34,  1099,  1473, -1430, -1430,    34,
   -1430,    34, -1430, -1430, -1430, -1430, -1430, -1430,  1131,  1136,
   -1430,  1146,   827,   828,    58,   948,    57,   113,   835, -1430,
     838,  1183,    58,  1096,    58,  1143,    58,  1155,   -27,    58,
      58,    57,  1156,   842,  1147,   843,    57,   852,    57,   333,
      57,   890,    57,   853,   857,    57,    57,    57,   859,  1102,
   -1430, -1430, -1430, -1430,    57, -1430,  1121, -1430, -1430, -1430,
    1218,   861,   862, -1430, -1430, -1430,    58, -1430,   866, -1430,
     869,  1150, -1430, -1430, -1430,   870,   871,   874,    58,   878,
     887,   893, -1430, -1430,   211, -1430,    57, -1430,   890, -1430,
   -1430,   837, -1430,   113, -1430,  1020, -1430, -1430, -1430,    58,
   -1430,    58, -1430,    57, -1430, -1430, -1430,    58, -1430,   113,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,   565, -1430,
   -1430,  1273, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430,   569, -1430, -1430,  1280, -1430, -1430, -1430,  1267, -1430,
    1277, -1430,   113, -1430, -1430,  1275,  1276, -1430,  1888, -1430,
   -1430, -1430, -1430,   113, -1430, -1430,  1278, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430,  1293,  1279,  1279,   700,
     680,  1279,   680,  1279, -1430, -1430,    58,   113, -1430,  1285,
    1287, -1430, -1430,   776, -1430, -1430, -1430, -1430,   117, -1430,
     924, -1430,  1282, -1430, -1430, -1430, -1430,   247,   272,   298,
    1082,   324,    66, -1430,  1473, -1430,  1473, -1430,  1297,   922,
     929,  1122,   118,   147, -1430, -1430, -1430,  1292,  1295, -1430,
    2164,  2164,  2164,  2525,  2525,  2164,  2164,  2164,  2164,   694,
     694,  1144,  1144, -1430,   936, -1430, -1430, -1430, -1430,  1721,
   -1430,  1887, -1430,   585, -1430,  1122,  1296, -1430, -1430, -1430,
   -1430, -1430,   940, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430,    33,   943,   934, -1430,
   -1430, -1430, -1430,   113,    58, -1430, -1430, -1430,  1093,  2604,
   -1430,   113, -1430, -1430,  1294, -1430,   939, -1430, -1430, -1430,
   -1430,  1227, -1430,    57,  2735, -1430, -1430,  2367,    58,    58,
      57, -1430, -1430,   947,    57,   951,   952, -1430, -1430,  1315,
    1215,   961,    58,   962,    58,   963,    58,   965,   966,   967,
     968,   971,    58, -1430,   710, -1430,   972, -1430,   973,   982,
     986,   991,   993,   995,   996, -1430, -1430,  1000,  1005,  1008,
   -1430,   232, -1430,    58,   782,  1009, -1430, -1430,  2247,  1013,
     116, -1430, -1430,   999,  1016, -1430, -1430, -1430,  1018, -1430,
   -1430, -1430,    58,   452,   583,  1007,  1023,  1024, -1430,  1183,
   -1430,   113,  1086,  1020, -1430, -1430, -1430, -1430,    49, -1430,
   -1430, -1430,  1065, -1430, -1430,   335, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430,  1403,  1404, -1430,
   -1430,   710, -1430,   710,  1395, -1430, -1430,   710,  1279,  1408,
    1279,  1410, -1430, -1430,  1298,  1299, -1430,  1473, -1430,  1387,
    1473,  1473,  1473, -1430,  1473, -1430,  1473,   525,  1500,  1473,
    1051,  1473, -1430, -1430, -1430, -1430,  1038,   744, -1430,  1473,
   -1430, -1430, -1430, -1430,   939, -1430, -1430, -1430,  2604,   180,
   -1430, -1430, -1430,  1046,  1045, -1430,  1306, -1430,   881, -1430,
     716, -1430, -1430, -1430, -1430,   113, -1430, -1430,  1049,  1050,
    1047,  1054, -1430,  1057, -1430, -1430, -1430,    58, -1430,  1058,
   -1430,  1074, -1430,  1076, -1430, -1430, -1430, -1430, -1430,  1078,
    1080, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430,  1085, -1430, -1430,    57,    80,   403, -1430,
    1158,   113, -1430, -1430,    52, -1430,  1087, -1430,  1118, -1430,
   -1430,   113, -1430, -1430,   113, -1430, -1430,  1092, -1430, -1430,
   -1430, -1430,  1150, -1430,  1094,  1439,  1439,  1439,  1439, -1430,
   -1430, -1430, -1430,  1183,    58,  1086, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430,  1471, -1430,  1472, -1430,  1463,  1465,
   -1430, -1430,  1550,  1575,  1600,  1634,   594,  1473, -1430, -1430,
    2735,  1103,  1098,  2735,  1468,  1671, -1430,     3, -1430,  1474,
   -1430, -1430,  1109,  1473, -1430, -1430, -1430,  1473,  1473,  1112,
      26,  2007,  1120,  1262, -1430,  2604, -1430,  1480,   113, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,  1117, -1430,
       0, -1430, -1430, -1430,    58, -1430, -1430,  1128, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430,    58,    58,    57,
      58, -1430,  1125,   710, -1430, -1430,  1132,  1153,    58, -1430,
   -1430,    58,  1159, -1430, -1430, -1430,  1160, -1430,   104,    14,
   -1430, -1430,   310, -1430,   211, -1430,  1138,  1165,  1175,  1177,
   -1430, -1430, -1430, -1430,   508,   508, -1430, -1430, -1430, -1430,
    1473,  1702,  1496,  1338,  1174, -1430,  1473,   846,  1473, -1430,
    1912,  2638,   639, -1430, -1430,  1494,   206, -1430,  2735,  1154,
    1187, -1430,  1396, -1430,   323, -1430, -1430,  1499,  1501,  1312,
    1188, -1430,  -167, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430,   348, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430,   178,    58,  1263,   407, -1430,
    1189, -1430,   211,   211,   211,   211,  1564,  1565,  1727, -1430,
    1191,  1192,     9, -1430,  1937,  1201,  1962,  1990, -1430,   691,
   -1430,  1473,  1473,   496,  1262, -1430,  1555, -1430,   157, -1430,
   -1430,   113,  1366, -1430,  1207,     4,   329,    29,   602, -1430,
   -1430,   836, -1430, -1430, -1430,    58,    58,    58, -1430, -1430,
     343, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430,  1473, -1430,  1473, -1430, -1430,
   -1430, -1430,  1210,   180,  1412, -1430,    20,  1992,  2017,  1214,
    1216,  1217,  1235,  1219, -1430,  1228,    57,   758,  1381,    58,
      58, -1430,  1237, -1430,    57, -1430, -1430, -1430, -1430, -1430,
   -1430,   374,    57,    58,    57, -1430,  1238, -1430,    58,    58,
      58,  1383,    47,   177, -1430, -1430,  1240,  2050, -1430,  1271,
    1274,    57,    57,    57, -1430,  1254,   219,   290, -1430, -1430,
   -1430,  1321, -1430,  1252,  1257,  1260,  1256,   691,    64, -1430,
   -1430, -1430,   734, -1430, -1430,  1641, -1430, -1430, -1430,   251,
   -1430, -1430,  1473,  1473,  1473,  1473, -1430, -1430, -1430,  1428,
    1436,  1437,   114, -1430, -1430, -1430, -1430,  2355, -1430,    58,
    1288, -1430, -1430, -1430, -1430, -1430, -1430, -1430,    58,    58,
   -1430, -1430, -1430, -1430, -1430,  1316,   113,   -58,  1305,  1314,
      57,  1329,  1597,  1330,  1446,  1457,  1458, -1430,  1307,    58,
      58, -1430, -1430, -1430, -1430,   152,   113, -1430,  1309,   152,
    1667, -1430,  1311, -1430,  1473, -1430, -1430, -1430, -1430, -1430,
    1752,   164,    64,   197,  1777,  1802,  1837,  1862,    58,    58,
      58, -1430, -1430, -1430,  1382,  1308,    57,  1391,   281,    58,
    1421,    57,    58,    58,    58,  1459,    58,   274,  1253,  1376,
     187,  1411,    58,  1388,  1416, -1430, -1430,  1331, -1430, -1430,
   -1430, -1430,  1502, -1430,    58,  1504,    58,    58, -1430,    57,
      58,    58,  1614,    57,   104,    57,    14, -1430,  1362,  1362,
      58, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
    1340, -1430,  1473, -1430, -1430, -1430,  1343,  1345,  1355,  1356,
   -1430, -1430, -1430,    57, -1430, -1430,   220,    58, -1430, -1430,
     458, -1430, -1430, -1430, -1430,    58, -1430,    58, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430,    57, -1430, -1430,
   -1430,    57, -1430,    58,    57, -1430,    58, -1430,    58,  1362,
   -1430, -1430, -1430, -1430,    58, -1430, -1430, -1430, -1430,    57,
   -1430, -1430, -1430, -1430,  1752, -1430, -1430, -1430, -1430, -1430,
       1, -1430, -1430, -1430, -1430,  1431, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,  1418, -1430,
   -1430, -1430, -1430,  1364, -1430
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1430, -1430, -1430, -1430,  -148,  -587,   -76,  -236,  -886,  -147,
    -679, -1430,  -146, -1430, -1430, -1430, -1430, -1430,  1242,   953,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
     529,  1405, -1430, -1430, -1430, -1430, -1430, -1430,  -278, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,  1344,  -101,
    1508, -1430,   207,  -444, -1430, -1430, -1430, -1430,   738,  -610,
   -1430, -1430,   230, -1430, -1430, -1430, -1430,   -30, -1430,   825,
     201, -1430,   823, -1142,   701,  -608, -1430,  -491, -1430, -1430,
   -1430, -1430,  -138, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430,  -241, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430,  1026,  1422, -1430,
   -1430, -1430, -1430,  -760,   792,   646,  1289,  1097,  1425, -1430,
     964, -1430, -1430, -1158, -1430,   377,  -168,  1035,   295,  -970,
     840, -1293, -1115,  1620, -1257,  1052,   305, -1430, -1430,  -178,
    1048, -1430, -1430, -1430, -1430,   431,   582, -1430, -1430,  -984,
   -1430,  -129,   677,   -17, -1430, -1430,   517,   850,   592, -1056,
   -1430, -1430, -1430, -1430,   808, -1430, -1430,   579, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430,   572, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430,   581, -1430, -1430, -1430,   -65, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430, -1430, -1430, -1430,   369,   350,
   -1430, -1430, -1430, -1430,   283,   349, -1430, -1430, -1430, -1430,
     284,   352, -1429, -1430, -1430, -1430, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1430,   915, -1430, -1430, -1430, -1430,
   -1430, -1430, -1430, -1430, -1101
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -431
static const yytype_int16 yytable[] =
{
     187,   431,   381,   382,   281,   602,   289,   900,   297,  1119,
     377,   425,   311,   904,   320,  1141,  1347,   331,   336,  1658,
     571,   573,   378,   379,   943,  1226,  1418,   501,   403,   397,
    1247,   424,  -292,  1092,  1271,  1419,  1420,  1421,   983,   622,
    1236,  -292,  -292,  -292,  -292,  1127,   390,   378,   379,   419,
     391,   506,   996,   422,   419,   420,   421,   162,   422,   392,
       1,   593,   419,  1426,   213,   591,   422,   419,  1003,   840,
    -291,   422,   419,   419,   867,  1128,   422,   422,   726,  -291,
    -291,  -291,  -291,  1127,  1234,   533,   534,   535,   536,   537,
     831,   534,   535,   536,   537,   765,   766,   188,   337,  1427,
     470,   471,   472,   473,   474,   189,   338,   570,  1292,   362,
    1129,   401,   565,  1128,   475,   476,   477,   478,   479,   480,
     481,   482,   378,   379,   483,   470,   471,   472,   473,   474,
    1631,   378,   379,   419,   420,   421,   983,   422,   605,   475,
     476,   477,   478,   479,   480,   481,   482,   883,  1129,   483,
     629,   406,  1511,  1512,  1513,   620,  1141,  1191,   626,   627,
    1459,   418,   419,   420,   421,   983,   422,   419,   504,   354,
     637,   422,   558,   559,   563,  1544,  1395,   355,   568,  1419,
    1420,  1421,   983,  1130,  1131,  1132,  1133,  1134,  1135,  1136,
    1655,   994,   198,   587,   917,  1416,  1352,   673,   199,  1127,
     529,   868,   598,  1137,   997,   419,  1138,  1210,   603,   422,
    1426,   606,  1419,  1420,  1421,   983,  1009,  1248,   566,   592,
     705,  1130,  1131,  1132,  1133,  1134,  1135,  1136,  1302,  1128,
     211,   716,  1414,   717,   718,   419,   721,   723,  1303,   422,
      67,  1137,   594,  1355,  1138,  1297,  1427,   419,   650,   363,
     652,   422,   378,   379,   833,   470,   471,   472,   473,   474,
    1499,   397,  1366,   397,  1129,   397,   397,   370,  1461,   475,
     476,   477,   478,   479,   480,   481,   482,  1545,  1608,   483,
     470,   471,   472,   473,   474,   821,   822,   823,   824,   419,
     402,   720,   912,   422,   475,   476,   477,   478,   479,   480,
     481,   482,   630,   631,   483,  1536,   470,   471,   472,   473,
     474,   579,   580,   623,   624,  1141,   370,  1325,  1326,   212,
     475,   476,   477,   478,   479,   480,   481,   482,   913,  1149,
     483,   856,   470,   471,   472,   473,   474,  1130,  1131,  1132,
    1133,  1134,  1135,  1136,  1574,   130,   475,   476,   477,   478,
     479,   480,   481,   482,   832,   572,   483,  1137,   419,   796,
    1138,  1355,   422,  1177,  1178,   502,  1367,  1368,   133,  1141,
    1369,  1370,   914,  1188,   138,  1413,   733,   534,   535,   536,
     537,  1227,   738,  1659,   371,  1003,  1378,  1597,  1348,   149,
     747,   748,   749,   750,   751,  1272,   841,   404,  1422,  1179,
     150,   841,  1423,   841,  -292,   919,   761,   920,  -292,   393,
     193,  1387,   505,   522,   206,   394,   853,   423,   419,   207,
    1325,  1326,   422,   928,   861,   505,   863,   679,   865,   727,
     505,   869,   870,  1141,  1141,   505,   505,   534,   535,   536,
     537,   553,  -291,   190,   339,   975,  -291,   507,   372,   976,
     767,   208,   687,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,  1327,   928,   899,  1243,
     680,   755,  1382,   419,   904,   756,  1462,   422,   370,  1463,
     908,   791,   209,   508,   509,  1267,  1609,   210,   795,  1610,
     855,   963,   534,   535,   536,   537,   505,  1079,  1560,  1009,
     967,   924,   722,   925,   513,   871,   514,   515,   763,   927,
     876,   764,   878,   214,   882,   356,   884,   215,  1141,   887,
     888,   889,  1275,   218,  1570,   423,   688,   124,   892,   844,
     505,  1641,  1642,   470,   471,   472,   473,   474,   825,  1371,
     345,  1276,  1572,   194,   342,   939,  1244,   475,   476,   477,
     478,   479,   480,   481,   482,  1411,  1085,   483,  1086,    68,
     916,   879,  -291,   689,  1252,   195,  1485,   569,   505,  1587,
     690,   768,  1486,   343,   769,  1422,   196,   926,   962,  1277,
     541,   691,   958,  1264,   960,   349,  1359,  1000,   200,    69,
     431,   880,   881,   516,   425,   425,  1040,    70,   505,   347,
      71,  1487,   470,   471,   472,   473,   474,   201,   348,  1052,
     505,    72,  1383,   373,   424,   424,   475,   476,   477,   478,
     479,   480,   481,   482,   374,   375,   483,   542,   543,   202,
     970,  1502,   549,    73,  1503,  1384,    74,  1489,    75,    76,
     353,  1278,  1360,  1361,  1490,   365,    77,   470,   471,   472,
     473,   474,   505,   948,   341,   971,   959,   344,   961,   120,
     121,   475,   476,   477,   478,   479,   480,   481,   482,   366,
    1645,   483,  1491,  1100,    78,  1101,  1001,   219,    79,  1103,
    1448,   972,   220,   122,  1006,  1093,  1180,  1087,  1449,  1088,
      80,   203,  1279,   120,   121,   221,   369,  1362,  1331,   370,
    1019,  1020,  1363,   949,  1245,   302,  1009,   974,   383,    81,
    1127,  1385,    82,  1281,  1029,   384,  1031,   122,  1033,   950,
     385,   505,   481,   482,  1039,   513,   483,   514,   515,  1319,
     304,  1009,   222,   358,   359,   583,   584,   977,   386,   978,
    1128,   611,   612,  1053,   546,  1054,  1017,   158,   387,   159,
     160,   161,   162,   163,   164,   388,   845,   360,   846,   783,
     165,   166,   757,   167,  1084,   168,   389,  1012,  1332,  1333,
    1334,  1335,   928,   398,  1021,  1129,   358,   359,  1023,  1160,
     951,   505,   784,   400,   470,   471,   472,   473,   474,   399,
     785,  1338,  1339,  1340,  1341,   786,   787,  1076,   475,   476,
     477,   478,   479,   480,   481,   482,   134,   135,   483,   797,
     798,   139,   140,  1152,  1153,  1154,  1155,   223,   169,   407,
     141,   731,   408,   732,   170,   734,   735,   158,   409,   159,
     160,   161,   162,   163,   164,   410,   505,  1388,   541,   142,
     165,   166,   411,   167,   143,   168,   144,   145,  1130,  1131,
    1132,  1133,  1134,  1135,  1136,   378,   379,   918,   412,   158,
     495,   159,   160,   161,   162,   163,   164,   497,  1137,  1055,
     498,  1138,   165,   166,   499,   167,   510,   168,   511,  1167,
     171,   172,   519,   224,   524,   542,   543,  1389,  1390,  1391,
     544,  1392,   521,  1104,   525,  1106,   545,   526,   169,   378,
     379,  1148,  1393,   528,   170,  1258,   788,   789,  1117,   530,
     146,   532,   928,   551,  1184,   173,   174,   413,   414,   415,
     416,  1580,  1581,  1582,  1195,  1056,   552,  1200,   952,   554,
     169,   555,   175,    83,   556,   176,   170,   560,   225,   177,
    1207,  1208,  1209,   226,   799,   800,  1211,   931,   932,   557,
     738,   934,   935,  1112,  1113,  1114,   561,  1115,   562,  1116,
     171,   172,  1268,   564,  1123,   567,   227,   992,   789,  1439,
    1440,   574,  1125,  1286,  1287,   953,   147,  1220,   151,   576,
    1176,   228,  1181,   575,  1394,   744,   745,   577,  1189,   578,
     954,   581,   171,   172,   585,   173,   174,   413,   414,   415,
     416,   582,   546,   590,   588,   586,   595,   589,   955,   596,
     597,  1057,   175,   152,   153,   176,  1250,   599,   600,   177,
    1300,   604,   956,   957,   601,   607,   608,   173,   174,  1253,
    1254,   609,  1256,   131,   132,   610,   136,   137,   613,   614,
    1261,   615,   124,  1262,   175,   192,   616,   176,   619,   621,
     628,   177,   632,   154,   155,   156,   157,   634,   633,   635,
     640,   638,   636,  1058,   158,   639,   159,   160,   161,   162,
     163,   164,  1353,   648,   148,  1373,   125,   165,   166,   757,
     167,   649,   168,   651,   126,   127,   128,  1059,   653,  1060,
     470,   471,   472,   473,   474,  1061,   654,  1062,   655,   656,
    1221,  1063,  1064,  1255,   475,   476,   477,   478,   479,   480,
     481,   482,   178,   657,   483,   658,  1230,   660,   670,   179,
    1231,  1232,   672,   641,   661,   675,  1238,   674,  1329,   676,
     470,   471,   472,   473,   474,   169,   677,   678,   683,   662,
     685,   170,   686,   724,   475,   476,   477,   478,   479,   480,
     481,   482,   725,   729,   483,   966,   642,   663,   664,   730,
     351,   352,   736,   742,  1065,   643,   737,   741,  1379,   743,
    1379,   752,   665,   666,   746,   667,   483,  1408,  1409,  1410,
    1399,  1400,   753,   754,  1401,  1402,  1403,   762,  1424,   790,
     792,   830,   178,   794,   803,   850,   827,   171,   172,   179,
     828,   843,   848,  1288,   851,   852,  1123,   849,   854,  1294,
     738,  1296,   857,   859,   864,   858,   893,   862,  1404,   873,
     875,  1442,  1444,   891,   178,  -430,   866,   872,   874,   877,
     885,   179,   173,   174,   886,  1452,   890,   895,   896,   897,
    1455,  1456,  1457,   901,  1460,   921,   902,   905,   906,   175,
    1268,   907,   176,   302,  1412,   909,   177,   804,   805,   806,
     807,   808,   809,   810,   910,   811,   812,   813,   814,   815,
     911,   644,   645,   646,   647,   158,   933,   159,   160,   161,
     162,   163,   164,   936,  1357,  1358,   937,  1238,   165,   166,
    1438,   167,   938,   168,   940,   941,   945,   944,  1446,   946,
     964,  1538,   965,   968,   979,   980,  1451,   986,  1453,   969,
    1540,  1541,   981,   987,   989,   999,   993,   995,  1268,  1195,
     998,  1007,  1009,  1010,  1022,  1481,  1482,  1483,  1024,  1025,
    1123,  1558,  1559,  1424,  1026,  1424,  1027,  1561,  1028,  1030,
    1032,  1561,  1034,  1035,  1036,  1037,   169,   230,  1038,  1041,
    1042,   158,   170,   159,   160,   161,   162,   163,   164,  1043,
    1442,  1442,  1442,  1044,   165,   166,  1291,   167,  1045,   168,
    1046,  1589,  1047,  1048,  1592,  1593,  1594,  1049,  1596,  1598,
     231,  1081,  1050,   232,  1612,  1051,  1069,   233,   234,  1089,
    1078,   236,   237,  1082,  1548,  1083,  1617,   238,  1619,  1620,
    1090,  1091,  1622,  1623,  1094,  1500,  1098,  1099,   171,   172,
    1102,  1105,  1632,  1107,  1111,  1504,  1505,  1506,  1507,  1108,
    1109,  1124,   169,  1145,  1146,  1147,  1162,  1163,   170,   178,
    1164,  1165,   239,   217,  1166,  1168,   179,   240,  1643,  1644,
    1585,   229,  1191,   173,   174,  1591,   244,  1647,   245,  1648,
     282,  1169,   293,  1170,   298,  1171,   299,  1172,   315,  1205,
     175,   973,  1173,   176,  1190,  1651,  1183,   177,  1653,  1201,
    1654,  1204,  1002,  1621,  1212,  1213,  1656,  1625,  1214,  1627,
    1215,  1223,  1222,  1224,   171,   172,   158,  1229,   159,   160,
     161,   162,   163,   164,  1233,  1242,  1228,  1237,  1245,   165,
     166,   982,   167,  1290,   168,  1251,  1257,  1639,   470,   471,
     472,   473,   474,  1259,  1646,  1282,  1301,  1306,  1309,   173,
     174,  1310,   475,   476,   477,   478,   479,   480,   481,   482,
    1311,  1649,   483,  1330,  1260,  1650,   175,  1304,  1652,   176,
    1263,  1265,  1283,   177,  1599,  1600,  1601,  1602,  1603,  1604,
    1605,  1606,  1284,  1657,  1285,  1634,  1293,   169,   470,   471,
     472,   473,   474,   170,  1305,  1313,  1337,  1342,  1343,  1345,
    1365,  1346,   475,   476,   477,   478,   479,   480,   481,   482,
    1350,  1374,   483,   470,   471,   472,   473,   474,  1376,  1415,
     708,  1417,  1432,  1441,  1433,  1434,  1436,   475,   476,   477,
     478,   479,   480,   481,   482,  1437,   709,   483,   470,   471,
     472,   473,   474,  1435,  1445,  1454,  1458,  1464,  1479,   171,
     172,  1480,   475,   476,   477,   478,   479,   480,   481,   482,
    1493,  1484,   483,   294,   295,  1494,  1495,  1496,  1497,  -425,
     178,  1508,   470,   471,   472,   473,   474,   179,  1501,  1509,
    1510,  1542,  1546,  1547,   173,   174,   475,   476,   477,   478,
     479,   480,   481,   482,   710,  1539,   483,  1549,  1550,   711,
     712,   175,  1551,  1552,   176,  1553,  1555,   713,   177,   470,
     471,   472,   473,   474,  1557,   296,  1565,  1271,  1569,  1584,
    1583,  1590,  1595,   475,   476,   477,   478,   479,   480,   481,
     482,  1586,  1607,   483,  1611,   714,  1613,  1614,  1615,  1624,
     470,   471,   472,   473,   474,  1616,   178,  1618,  1629,  1633,
    1635,  1662,  1636,   179,   475,   476,   477,   478,   479,   480,
     481,   482,  1637,  1638,   483,   470,   471,   472,   473,   474,
    1661,  1664,   990,   715,   793,   550,   671,  1151,  1588,   475,
     476,   477,   478,   479,   480,   481,   482,  1096,  1097,   483,
     470,   471,   472,   473,   474,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   475,   476,   477,   478,   479,   480,
     481,   482,   684,  1203,   483,   470,   471,   472,   473,   474,
    1126,  1241,   707,  1005,  1498,   942,  1573,   984,   417,   475,
     476,   477,   478,   479,   480,   481,   482,   819,  1575,   483,
     470,   471,   472,   473,   474,   985,   988,  1110,  1235,  1295,
    1121,  1364,  1158,  1307,   475,   476,   477,   478,   479,   480,
     481,   482,  1317,  1314,   483,  1543,  1563,  1626,  1095,  1567,
    1628,  1566,     0,     0,     0,   470,   471,   472,   473,   474,
       0,   178,     0,     0,     0,     0,     0,     0,   179,   475,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     470,   471,   472,   473,   474,     0,     0,     0,     0,  1118,
       0,     0,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   470,   471,   472,   473,   474,
       0,     0,     0,     0,     0,     0,     0,   837,     0,   475,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     470,   471,   472,   473,   474,     0,     0,     0,     0,  1216,
       0,     0,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   470,   471,   472,   473,   474,
       0,     0,     0,     0,  1217,     0,     0,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     470,   471,   472,   473,   474,     0,     0,     0,     0,  1218,
       0,     0,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   434,     0,     0,     0,     0,
     470,   471,   472,   473,   474,     0,     0,     0,     0,     0,
       0,     0,   434,  1219,   475,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   470,   471,   472,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
    1225,     0,   804,   805,   806,   807,   808,   809,   810,   230,
     811,   812,   813,   814,   815,   435,   436,     0,   437,   438,
       0,     0,   230,     0,     0,     0,     0,     0,     0,     0,
     300,  1289,   435,   436,     0,   437,   438,     0,     0,     0,
       0,     0,   231,     0,     0,   232,     0,     0,     0,   233,
     234,     0,   301,   236,   237,   231,  1344,     0,   232,   238,
       0,   439,   233,   234,     0,     0,   236,   237,   302,     0,
       0,     0,   238,     0,     0,     0,     0,     0,   440,     0,
       0,  1571,     0,     0,     0,   230,     0,     0,     0,     0,
       0,     0,   303,   304,   239,   440,     0,     0,     0,   240,
       0,     0,     0,     0,     0,     0,  1576,   239,     0,   323,
     324,   325,   240,   326,   327,     0,     0,     0,   231,  1465,
       0,   232,  -431,  -431,  -431,   233,   234,     0,     0,   236,
     237,  1577,     0,     0,     0,   238,  -431,  -431,  -431,  -431,
     479,   480,   481,   482,   441,   442,   483,   443,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1578,  1466,     0,     0,
     239,     0,     0,     0,     0,   240,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,     0,     0,     0,
       0,  1579,     0,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,     0,   230,     0,  1467,
       0,     0,   246,     0,   991,     0,   461,   462,   463,   464,
     459,   460,     0,     0,     0,     0,     0,     0,     0,  1468,
       0,     0,     0,   461,   462,   463,   464,     0,     0,  1298,
     231,   230,     0,   232,     0,     0,     0,   233,   234,   247,
       0,   236,   237,   283,     0,     0,     0,   238,   284,   285,
     286,     0,     0,   248,  1349,   305,   249,     0,   250,     0,
       0,     0,     0,     0,   231,     0,     0,   232,     0,     0,
       0,   233,   234,     0,  1070,   236,   237,     0,     0,  1351,
       0,   238,   239,     0,     0,   287,     0,   240,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   251,  1469,     0,
     465,   466,     0,     0,     0,     0,     0,     0,   252,  1430,
       0,     0,   230,   306,   307,   308,   239,   465,   466,     0,
       0,   240,   309,     0,     0,     0,  1470,  1471,     0,     0,
    1472,  1473,   316,  1474,  1431,     0,     0,   310,     0,     0,
       0,  1475,  1476,     0,   253,   231,     0,     0,   232,     0,
     288,   230,   233,   234,  1071,     0,   236,   237,     0,  1514,
       0,   254,   238,     0,     0,     0,     0,     0,   255,   256,
       0,   257,  1477,   258,   259,     0,   260,   261,     0,   262,
       0,     0,   263,   264,   231,   265,     0,   232,     0,     0,
       0,   233,   234,     0,  1013,   236,   237,   239,   302,   266,
     267,   238,   240,     0,   268,     0,   269,   270,     0,   271,
       0,   230,   317,   328,   272,     0,     0,     0,   273,   274,
       0,   275,   276,   304,   277,   278,   279,   230,     0,     0,
       0,     0,     0,     0,     0,     0,   239,   332,     0,     0,
       0,   240,   693,     0,   231,     0,  1515,   232,     0,     0,
       0,   233,   234,     0,     0,   236,   237,   378,   379,     0,
     231,   238,     0,   232,     0,     0,     0,   233,   234,     0,
     235,   236,   237,   470,   471,   472,     0,   238,   333,     0,
       0,     0,   694,     0,     0,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,     0,   239,   483,     0,     0,
       0,   240,     0,  1516,     0,     0,  1517,  1518,     0,     0,
       0,     0,   239,     0,     0,     0,   695,   240,     0,     0,
       0,   696,  1014,  1015,     0,     0,     0,     0,   697,   698,
    1519,     0,     0,   318,     0,   280,     0,     0,  1072,  1073,
       0,   699,  1074,     0,     0,     0,     0,     0,     0,     0,
     700,   701,   702,   703,     0,   704,     0,     0,     0,     0,
       0,     0,     0,     0,  1520,     0,     0,     0,     0,  1075,
       0,     4,     0,     0,     0,     0,  1521,     0,  1522,     0,
    1523,  1524,  1525,  1526,  1527,  1528,   470,   471,   472,   473,
     474,  1529,     0,     5,     6,  1530,  1531,     0,     0,  1532,
     475,   476,   477,   478,   479,   480,   481,   482,     0,   469,
     483,     0,  1533,     0,   470,   471,   472,   473,   474,     0,
    1534,     0,     0,     0,     0,     0,     7,     8,   475,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,     0,
       0,     0,     0,     0,     0,     0,   546,     9,     0,     0,
     319,     0,     0,     0,     0,     0,     0,     0,    10,     0,
       0,    11,     0,    12,     0,     0,     0,     0,    13,     0,
       0,     0,     0,    14,    15,    16,     0,  1535,     0,     0,
      17,    18,    19,   470,   471,   472,   473,   474,     0,  1016,
       0,     0,     0,     0,     0,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   804,   805,
     806,   807,   808,   809,   810,     0,   811,   812,   813,   814,
     815,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   334,
       0,     0,     0,     0,     0,     0,  1299,     0,     0,     0,
       0,     0,     0,     0,     0,   241
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1430)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-431)))

static const yytype_int16 yycheck[] =
{
      17,   179,   149,   150,   105,   283,   107,   617,   109,   979,
     148,   179,   113,   621,   115,   999,     7,   118,   119,    18,
     256,   257,    18,    19,   703,    22,     6,    43,    15,   158,
      30,   179,     6,   919,    20,    15,    16,    17,    18,    91,
    1141,    15,    16,    17,    18,    19,    15,    18,    19,    15,
      19,   199,    19,    19,    15,    16,    17,    18,    19,    28,
       4,    86,    15,  1356,    81,    77,    19,    15,   828,    35,
       6,    19,    15,    15,   101,    49,    19,    19,    29,    15,
      16,    17,    18,    19,  1140,   233,    34,    35,    36,    37,
     118,    34,    35,    36,    37,    26,    27,    35,    35,  1356,
       8,     9,    10,    11,    12,    43,    43,   255,  1223,     3,
      84,    27,   144,    49,    22,    23,    24,    25,    26,    27,
      28,    29,    18,    19,    32,     8,     9,    10,    11,    12,
    1559,    18,    19,    15,    16,    17,    18,    19,   286,    22,
      23,    24,    25,    26,    27,    28,    29,   591,    84,    32,
     216,   168,    38,    39,    40,   303,  1140,   324,   306,   307,
     113,   178,    15,    16,    17,    18,    19,    15,   198,    35,
     317,    19,   234,   235,   250,   233,  1318,    43,   254,    15,
      16,    17,    18,   157,   158,   159,   160,   161,   162,   163,
    1619,   801,   109,   269,   638,  1353,  1297,   345,   115,    19,
     230,   228,   278,   177,   171,    15,   180,  1093,   284,    19,
    1503,   287,    15,    16,    17,    18,   383,   217,   250,   231,
     367,   157,   158,   159,   160,   161,   162,   163,    22,    49,
      20,   369,  1347,   371,   372,    15,   374,   375,    32,    19,
       0,   177,   267,  1299,   180,  1229,  1503,    15,   324,   143,
     326,    19,    18,    19,   532,     8,     9,    10,    11,    12,
    1418,   390,   105,   392,    84,   394,   395,    19,    91,    22,
      23,    24,    25,    26,    27,    28,    29,   335,    91,    32,
       8,     9,    10,    11,    12,   124,   125,   126,   127,    15,
     206,    43,    81,    19,    22,    23,    24,    25,    26,    27,
      28,    29,   368,   369,    32,  1447,     8,     9,    10,    11,
      12,   238,   239,   365,   366,  1299,    19,   139,   140,   109,
      22,    23,    24,    25,    26,    27,    28,    29,   117,  1008,
      32,   567,     8,     9,    10,    11,    12,   157,   158,   159,
     160,   161,   162,   163,  1502,     3,    22,    23,    24,    25,
      26,    27,    28,    29,   382,   121,    32,   177,    15,   507,
     180,  1417,    19,   283,   284,   381,   209,   210,   118,  1353,
     213,   214,   161,   321,     3,  1345,   393,    34,    35,    36,
      37,   378,   399,   382,    87,  1145,   382,   113,   379,   118,
     407,   408,   409,   410,   411,   381,   544,   384,   378,   319,
     118,   549,   382,   551,   378,   641,   423,   643,   382,   378,
      19,   382,   378,   212,    19,   384,   564,   378,    15,    81,
     139,   140,    19,   659,   572,   378,   574,    92,   576,   380,
     378,   579,   580,  1417,  1418,   378,   378,    34,    35,    36,
      37,   240,   378,   381,   381,   379,   382,    20,   151,   383,
     381,    19,     3,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   288,   703,   616,  1148,
     135,   379,   143,    15,  1082,   383,   299,    19,    19,   302,
     628,   498,    77,    56,    57,   381,   299,   123,   505,   302,
     566,   727,    34,    35,    36,    37,   378,   381,   346,   383,
     383,   649,    43,   651,    15,   581,    17,    18,   383,   657,
     586,   386,   588,    19,   590,   381,   592,    19,  1502,   595,
     596,   597,   212,   381,  1494,   378,    77,    20,   604,   546,
     378,   311,   312,     8,     9,    10,    11,    12,   377,   382,
      65,   231,   378,    20,     3,   692,  1156,    22,    23,    24,
      25,    26,    27,    28,    29,   212,   104,    32,   106,     3,
     636,   228,   382,   114,  1174,    42,   347,   377,   378,   288,
     121,   383,   353,     3,   386,   378,    53,   653,   726,   269,
      43,   132,   720,  1193,   722,    77,    90,   823,    41,    33,
     768,   258,   259,   104,   762,   763,   874,    41,   378,     3,
      44,   382,     8,     9,    10,    11,    12,    60,     3,   377,
     378,    55,   283,   316,   762,   763,    22,    23,    24,    25,
      26,    27,    28,    29,   327,   328,    32,    90,    91,    82,
     383,   380,    95,    77,   383,   306,    80,   347,    82,    83,
       3,   331,   146,   147,   354,     3,    90,     8,     9,    10,
      11,    12,   378,   718,   125,   383,   721,   128,   723,    19,
      20,    22,    23,    24,    25,    26,    27,    28,    29,     3,
     212,    32,   382,   951,   118,   953,   824,    68,   122,   957,
     306,   383,    73,    43,   831,   921,   283,   104,   314,   106,
     134,   144,   382,    19,    20,    86,   219,   201,   291,    19,
     848,   849,   206,     3,   381,   103,   383,   383,     3,   153,
      19,   382,   156,  1204,   862,     3,   864,    43,   866,    19,
       3,   378,    28,    29,   872,    15,    32,    17,    18,   381,
     128,   383,   123,    19,    20,   248,   249,   754,     3,   756,
      49,   332,   333,   891,   207,   893,   847,    13,     3,    15,
      16,    17,    18,    19,    20,     3,   549,    43,   551,   166,
      26,    27,    28,    29,   912,    31,     3,   843,   361,   362,
     363,   364,  1008,    29,   850,    84,    19,    20,   854,  1015,
      80,   378,   189,   206,     8,     9,    10,    11,    12,   378,
     197,  1282,  1283,  1284,  1285,   202,   203,   898,    22,    23,
      24,    25,    26,    27,    28,    29,   132,   133,    32,    58,
      59,   109,   110,    97,    98,    99,   100,   208,    84,   378,
     118,   390,   378,   392,    90,   394,   395,    13,   378,    15,
      16,    17,    18,    19,    20,   378,   378,   235,    43,   137,
      26,    27,   378,    29,   142,    31,   144,   145,   157,   158,
     159,   160,   161,   162,   163,    18,    19,    20,   378,    13,
      15,    15,    16,    17,    18,    19,    20,     3,   177,    87,
      22,   180,    26,    27,    61,    29,   377,    31,   130,  1027,
     146,   147,    19,   274,   104,    90,    91,   285,   286,   287,
      95,   289,   377,   958,   381,   960,   101,   381,    84,    18,
      19,    20,   300,   381,    90,  1183,   382,   383,   383,    19,
     208,    81,  1148,    95,  1061,   181,   182,   183,   184,   185,
     186,  1508,  1509,  1510,  1071,   143,    20,  1074,   228,   377,
      84,   377,   198,   377,   381,   201,    90,   377,   329,   205,
    1086,  1087,  1088,   334,    58,    59,  1094,   382,   383,   381,
     967,   382,   383,   970,   971,   972,   236,   974,    20,   976,
     146,   147,  1198,    95,   981,   126,   357,   382,   383,   211,
     212,    71,   989,  1214,  1215,   275,   274,   383,    74,    71,
    1056,   372,  1058,   222,   382,   403,   404,   220,  1064,   227,
     290,   231,   146,   147,   248,   181,   182,   183,   184,   185,
     186,   233,   207,   262,   255,   252,   231,   257,   308,   270,
     268,   229,   198,   109,   110,   201,  1164,   218,   377,   205,
     381,    80,   322,   323,   381,   377,   381,   181,   182,  1177,
    1178,   381,  1180,     7,     8,    77,    10,    11,   377,   381,
    1188,   381,    20,  1191,   198,    19,    71,   201,    20,   381,
      71,   205,   377,   149,   150,   151,   152,   381,   377,   381,
     162,    77,   308,   281,    13,   377,    15,    16,    17,    18,
      19,    20,   381,   377,   372,  1311,    54,    26,    27,    28,
      29,    77,    31,    71,    62,    63,    64,   305,    74,   307,
       8,     9,    10,    11,    12,   313,   377,   315,   377,   377,
    1117,   319,   320,  1179,    22,    23,    24,    25,    26,    27,
      28,    29,   378,    71,    32,    20,  1133,   377,     3,   385,
    1137,  1138,     3,   225,   377,    19,  1143,     3,  1276,     3,
       8,     9,    10,    11,    12,    84,     3,     3,     3,    74,
       3,    90,     3,     3,    22,    23,    24,    25,    26,    27,
      28,    29,     3,   119,    32,   379,   258,    92,    93,   119,
     134,   135,    14,   206,   382,   267,    15,    26,  1315,    27,
    1317,    19,   107,   108,    29,   110,    32,  1325,  1326,  1327,
     344,   345,    15,   383,   348,   349,   350,     7,  1356,     3,
      20,    19,   378,   377,   377,    49,   377,   146,   147,   385,
     378,   102,    71,  1220,   377,   377,  1223,    71,   260,  1226,
    1227,  1228,   377,    30,    71,   377,    95,   121,   382,   377,
     377,  1369,  1370,   121,   378,   379,    71,    71,    81,   377,
     377,   385,   181,   182,   377,  1383,   377,    19,   377,   377,
    1388,  1389,  1390,   377,  1392,   225,   377,   377,   377,   198,
    1486,   377,   201,   103,  1330,   377,   205,   164,   165,   166,
     167,   168,   169,   170,   377,   172,   173,   174,   175,   176,
     377,   373,   374,   375,   376,    13,     3,    15,    16,    17,
      18,    19,    20,     3,  1301,  1302,    19,  1304,    26,    27,
    1366,    29,    15,    31,    19,    19,     3,    19,  1374,    20,
      15,  1449,    15,   379,     7,   383,  1382,    15,  1384,    27,
    1458,  1459,   383,    18,   378,   381,    20,   377,  1554,  1466,
     377,    27,   383,    96,   377,  1401,  1402,  1403,   377,   377,
    1347,  1479,  1480,  1501,    19,  1503,   121,  1485,   377,   377,
     377,  1489,   377,   377,   377,   377,    84,    44,   377,   377,
     377,    13,    90,    15,    16,    17,    18,    19,    20,   377,
    1508,  1509,  1510,   377,    26,    27,    28,    29,   377,    31,
     377,  1519,   377,   377,  1522,  1523,  1524,   377,  1526,  1527,
      77,   382,   377,    80,  1532,   377,   377,    84,    85,   382,
     377,    88,    89,   377,  1470,   377,  1544,    94,  1546,  1547,
     377,   377,  1550,  1551,   318,  1422,     3,     3,   146,   147,
      15,     3,  1560,     3,    27,  1432,  1433,  1434,  1435,   121,
     121,   383,    84,   377,   379,   119,   377,   377,    90,   378,
     383,   377,   129,    89,   377,   377,   385,   134,  1586,  1587,
    1516,    97,   324,   181,   182,  1521,   102,  1595,   104,  1597,
     106,   377,   108,   377,   110,   377,   112,   377,   114,    20,
     198,   379,   377,   201,   377,  1613,   308,   205,  1616,   377,
    1618,   377,   379,  1549,     3,     3,  1624,  1553,    15,  1555,
      15,   383,   379,    15,   146,   147,    13,   378,    15,    16,
      17,    18,    19,    20,   382,    15,    22,   377,   381,    26,
      27,   379,    29,     7,    31,   377,   381,  1583,     8,     9,
      10,    11,    12,   381,  1590,   377,    22,   121,    19,   181,
     182,    20,    22,    23,    24,    25,    26,    27,    28,    29,
     218,  1607,    32,   270,   381,  1611,   198,   383,  1614,   201,
     381,   381,   377,   205,   291,   292,   293,   294,   295,   296,
     297,   298,   377,  1629,   377,  1572,   382,    84,     8,     9,
      10,    11,    12,    90,   377,   377,   377,     3,     3,   378,
      15,   379,    22,    23,    24,    25,    26,    27,    28,    29,
     379,   215,    32,     8,     9,    10,    11,    12,   381,   379,
       3,   179,   378,   212,   378,   378,   377,    22,    23,    24,
      25,    26,    27,    28,    29,   377,    19,    32,     8,     9,
      10,    11,    12,   378,   377,   377,   233,   377,   347,   146,
     147,   347,    22,    23,    24,    25,    26,    27,    28,    29,
     309,   377,    32,   330,   331,   383,   379,   377,   382,   377,
     378,   213,     8,     9,    10,    11,    12,   385,     7,   213,
     213,   335,   347,   339,   181,   182,    22,    23,    24,    25,
      26,    27,    28,    29,    77,   377,    32,   338,    71,    82,
      83,   198,   342,   227,   201,   218,   218,    90,   205,     8,
       9,    10,    11,    12,   377,   382,   377,    20,   377,   381,
     308,   270,   233,    22,    23,    24,    25,    26,    27,    28,
      29,   310,   326,    32,   293,   118,   318,   291,   377,    95,
       8,     9,    10,    11,    12,   213,   378,   213,   356,   379,
     377,   303,   377,   385,    22,    23,    24,    25,    26,    27,
      28,    29,   377,   377,    32,     8,     9,    10,    11,    12,
     309,   377,   789,   156,   502,   237,   341,  1009,  1518,    22,
      23,    24,    25,    26,    27,    28,    29,   932,   935,    32,
       8,     9,    10,    11,    12,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    22,    23,    24,    25,    26,    27,
      28,    29,   360,  1082,    32,     8,     9,    10,    11,    12,
     998,  1145,   367,   829,  1417,   698,  1501,   762,   178,    22,
      23,    24,    25,    26,    27,    28,    29,   518,  1503,    32,
       8,     9,    10,    11,    12,   763,   768,   967,  1141,  1227,
     980,  1304,  1014,  1244,    22,    23,    24,    25,    26,    27,
      28,    29,  1260,  1252,    32,  1466,  1486,  1554,   923,  1490,
    1556,  1489,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,   378,    -1,    -1,    -1,    -1,    -1,    -1,   385,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,   379,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,   379,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,   379,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,   379,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     5,    -1,    -1,    -1,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     5,   379,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
     379,    -1,   164,   165,   166,   167,   168,   169,   170,    44,
     172,   173,   174,   175,   176,    75,    76,    -1,    78,    79,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,   379,    75,    76,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    77,    -1,    -1,    80,    -1,    -1,    -1,    84,
      85,    -1,    87,    88,    89,    77,   379,    -1,    80,    94,
      -1,   104,    84,    85,    -1,    -1,    88,    89,   103,    -1,
      -1,    -1,    94,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,   379,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,   127,   128,   129,   138,    -1,    -1,    -1,   134,
      -1,    -1,    -1,    -1,    -1,    -1,   379,   129,    -1,    68,
      69,    70,   134,    72,    73,    -1,    -1,    -1,    77,   119,
      -1,    80,     8,     9,    10,    84,    85,    -1,    -1,    88,
      89,   379,    -1,    -1,    -1,    94,    22,    23,    24,    25,
      26,    27,    28,    29,   187,   188,    32,   190,   191,   192,
     193,   194,   195,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   379,   167,    -1,    -1,
     129,    -1,    -1,    -1,    -1,   134,    -1,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,    -1,    -1,
      -1,   379,    -1,    -1,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   263,   264,    -1,    -1,    44,    -1,   209,
      -1,    -1,    49,    -1,   377,    -1,   276,   277,   278,   279,
     263,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,   276,   277,   278,   279,    -1,    -1,   377,
      77,    44,    -1,    80,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,   275,    -1,    -1,    -1,    94,   280,   281,
     282,    -1,    -1,   100,   377,   300,   103,    -1,   105,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    -1,    80,    -1,    -1,
      -1,    84,    85,    -1,    87,    88,    89,    -1,    -1,   377,
      -1,    94,   129,    -1,    -1,   317,    -1,   134,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,   308,    -1,
     370,   371,    -1,    -1,    -1,    -1,    -1,    -1,   155,   377,
      -1,    -1,    44,   358,   359,   360,   129,   370,   371,    -1,
      -1,   134,   367,    -1,    -1,    -1,   336,   337,    -1,    -1,
     340,   341,    64,   343,   377,    -1,    -1,   382,    -1,    -1,
      -1,   351,   352,    -1,   191,    77,    -1,    -1,    80,    -1,
     382,    44,    84,    85,   167,    -1,    88,    89,    -1,    64,
      -1,   208,    94,    -1,    -1,    -1,    -1,    -1,   215,   216,
      -1,   218,   382,   220,   221,    -1,   223,   224,    -1,   226,
      -1,    -1,   229,   230,    77,   232,    -1,    80,    -1,    -1,
      -1,    84,    85,    -1,    87,    88,    89,   129,   103,   246,
     247,    94,   134,    -1,   251,    -1,   253,   254,    -1,   256,
      -1,    44,   144,   382,   261,    -1,    -1,    -1,   265,   266,
      -1,   268,   269,   128,   271,   272,   273,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,    70,    -1,    -1,
      -1,   134,     3,    -1,    77,    -1,   151,    80,    -1,    -1,
      -1,    84,    85,    -1,    -1,    88,    89,    18,    19,    -1,
      77,    94,    -1,    80,    -1,    -1,    -1,    84,    85,    -1,
      87,    88,    89,     8,     9,    10,    -1,    94,   111,    -1,
      -1,    -1,    43,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,   129,    32,    -1,    -1,
      -1,   134,    -1,   208,    -1,    -1,   211,   212,    -1,    -1,
      -1,    -1,   129,    -1,    -1,    -1,    77,   134,    -1,    -1,
      -1,    82,   215,   216,    -1,    -1,    -1,    -1,    89,    90,
     235,    -1,    -1,   265,    -1,   382,    -1,    -1,   351,   352,
      -1,   102,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,    -1,   116,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,   382,
      -1,    44,    -1,    -1,    -1,    -1,   281,    -1,   283,    -1,
     285,   286,   287,   288,   289,   290,     8,     9,    10,    11,
      12,   296,    -1,    66,    67,   300,   301,    -1,    -1,   304,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,     3,
      32,    -1,   317,    -1,     8,     9,    10,    11,    12,    -1,
     325,    -1,    -1,    -1,    -1,    -1,    99,   100,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   207,   120,    -1,    -1,
     382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,
      -1,   134,    -1,   136,    -1,    -1,    -1,    -1,   141,    -1,
      -1,    -1,    -1,   146,   147,   148,    -1,   382,    -1,    -1,
     153,   154,   155,     8,     9,    10,    11,    12,    -1,   382,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,
      -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   382
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   388,   389,    44,    66,    67,    99,   100,   120,
     131,   134,   136,   141,   146,   147,   148,   153,   154,   155,
     411,   412,   413,   414,   415,   416,   465,   466,   467,   468,
     470,   471,   472,   475,   478,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   571,   605,   606,   607,
     608,   609,   610,   611,   612,   665,   667,     0,     3,    33,
      41,    44,    55,    77,    80,    82,    83,    90,   118,   122,
     134,   153,   156,   377,   390,   401,   407,   410,   419,   421,
     424,   426,   430,   431,   433,   434,   441,   450,   451,   506,
     508,   518,   557,   560,   572,   573,   574,   575,   614,   615,
     616,   621,   650,   651,   659,   660,   666,   668,   669,   670,
      19,    20,    43,   504,    20,    54,    62,    63,    64,   417,
       3,   504,   504,   118,   132,   133,   504,   504,     3,   109,
     110,   118,   137,   142,   144,   145,   208,   274,   372,   118,
     118,    74,   109,   110,   149,   150,   151,   152,    13,    15,
      16,    17,    18,    19,    20,    26,    27,    29,    31,    84,
      90,   146,   147,   181,   182,   198,   201,   205,   378,   385,
     523,   536,   541,   544,   545,   546,   548,   550,    35,    43,
     381,   493,   504,    19,    20,    42,    53,   403,   109,   115,
      41,    60,    82,   144,   408,   409,    19,    81,    19,    77,
     123,    20,   109,   550,    19,    19,   435,   435,   381,    68,
      73,    86,   123,   208,   274,   329,   334,   357,   372,   435,
      44,    77,    80,    84,    85,    87,    88,    89,    94,   129,
     134,   382,   436,   453,   435,   435,    49,    86,   100,   103,
     105,   144,   155,   191,   208,   215,   216,   218,   220,   221,
     223,   224,   226,   229,   230,   232,   246,   247,   251,   253,
     254,   256,   261,   265,   266,   268,   269,   271,   272,   273,
     382,   436,   435,   275,   280,   281,   282,   317,   382,   436,
     576,   577,   578,   435,   330,   331,   382,   436,   435,   435,
      65,    87,   103,   127,   128,   300,   358,   359,   360,   367,
     382,   436,   460,   462,   463,   435,    64,   144,   265,   382,
     436,   661,   664,    68,    69,    70,    72,    73,   382,   420,
     423,   436,    70,   111,   382,   422,   436,    35,    43,   381,
     454,   417,     3,     3,   417,    65,   418,     3,     3,    77,
     480,   504,   504,     3,    35,    43,   381,   457,    19,    20,
      43,   505,     3,   143,   476,     3,     3,   473,   479,   219,
      19,    87,   151,   316,   327,   328,   469,   469,    18,    19,
     394,   396,   396,     3,     3,     3,     3,     3,     3,     3,
      15,    19,    28,   378,   384,   540,   542,   548,    29,   378,
     206,    27,   206,    15,   384,   543,   550,   378,   378,   378,
     378,   378,   378,   183,   184,   185,   186,   530,   550,    15,
      16,    17,    19,   378,   391,   523,   524,   528,   531,   532,
     534,   536,   537,   538,     5,    75,    76,    78,    79,   104,
     138,   187,   188,   190,   191,   192,   193,   194,   195,   196,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   263,
     264,   276,   277,   278,   279,   370,   371,   549,   671,     3,
       8,     9,    10,    11,    12,    22,    23,    24,    25,    26,
      27,    28,    29,    32,    44,    45,    46,    47,    48,    49,
      50,    51,    52,   405,   406,    15,   494,     3,    22,    61,
     402,    43,   381,   404,   454,   378,   391,    20,    56,    57,
     377,   130,   429,    15,    17,    18,   104,   425,   507,    19,
     427,   377,   457,   519,   104,   381,   381,   432,   381,   454,
      19,   440,    81,   391,    34,    35,    36,    37,   391,   393,
     452,    43,    90,    91,    95,   101,   207,   437,   515,    95,
     437,    95,    20,   457,   377,   377,   381,   381,   234,   235,
     377,   236,    20,   393,    95,   144,   250,   126,   393,   377,
     391,   394,   121,   394,    71,   222,    71,   220,   227,   238,
     239,   231,   233,   248,   249,   248,   252,   393,   255,   257,
     262,    77,   231,    86,   267,   231,   270,   268,   393,   218,
     377,   381,   425,   393,    80,   391,   393,   377,   381,   381,
      77,   332,   333,   377,   381,   381,    71,   657,   658,    20,
     391,   381,    91,   365,   366,   652,   391,   391,    71,   216,
     368,   369,   377,   377,   381,   381,   308,   396,    77,   377,
     162,   225,   258,   267,   373,   374,   375,   376,   377,    77,
     393,    71,   393,    74,   377,   377,   377,    71,    20,   400,
     377,   377,    74,    92,    93,   107,   108,   110,   455,   456,
       3,   418,     3,   391,     3,    19,     3,     3,     3,    92,
     135,   458,   459,     3,   505,     3,     3,     3,    77,   114,
     121,   132,   477,     3,    43,    77,    82,    89,    90,   102,
     111,   112,   113,   114,   116,   396,   474,   515,     3,    19,
      77,    82,    83,    90,   118,   156,   469,   469,   469,   613,
      43,   469,    43,   469,     3,     3,    29,   380,   398,   119,
     119,   542,   542,   550,   542,   542,    14,    15,   550,   554,
     555,    26,   206,    27,   543,   543,    29,   550,   550,   550,
     550,   550,    19,    15,   383,   379,   383,    28,   526,   527,
     530,   550,     7,   383,   386,    26,    27,   381,   383,   386,
     550,   550,   550,   550,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   166,   189,   197,   202,   203,   382,   383,
       3,   550,    20,   405,   377,   550,   391,    58,    59,    58,
      59,   447,   448,   377,   164,   165,   166,   167,   168,   169,
     170,   172,   173,   174,   175,   176,   509,   510,   511,   513,
     517,   124,   125,   126,   127,   377,   428,   377,   378,   516,
      19,   118,   382,   425,   442,   445,   446,    19,   513,   514,
      35,   391,   439,   102,   550,   439,   439,   559,    71,    71,
      49,   377,   377,   391,   260,   393,   394,   377,   377,    30,
     395,   391,   121,   391,    71,   391,    71,   101,   228,   391,
     391,   393,    71,   377,    81,   377,   393,   377,   393,   228,
     258,   259,   393,   440,   393,   377,   377,   393,   393,   393,
     377,   121,   393,    95,   579,    19,   377,   377,   620,   391,
     446,   377,   377,   461,   462,   377,   377,   377,   391,   377,
     377,   377,    81,   117,   161,   464,   393,   440,    20,   394,
     394,   225,   662,   663,   391,   391,   393,   391,   394,   396,
     397,   382,   383,     3,   382,   383,     3,    19,    15,   396,
      19,    19,   514,   397,    19,     3,    20,   604,   604,     3,
      19,    80,   228,   275,   290,   308,   322,   323,   469,   604,
     469,   604,   391,   394,    15,    15,   379,   383,   379,    27,
     383,   383,   383,   379,   383,   379,   383,   550,   550,     7,
     383,   383,   379,    18,   524,   532,    15,    18,   537,   378,
     406,   377,   382,    20,   446,   377,    19,   171,   377,   381,
     394,   391,   379,   510,   512,   517,   396,    27,   444,   383,
      96,   438,   393,    87,   215,   216,   382,   436,   558,   391,
     391,   393,   377,   393,   377,   377,    19,   121,   377,   391,
     377,   391,   377,   391,   377,   377,   377,   377,   377,   391,
     425,   377,   377,   377,   377,   377,   377,   377,   377,   377,
     377,   377,   377,   391,   391,    87,   143,   229,   281,   305,
     307,   313,   315,   319,   320,   382,   580,   587,   590,   377,
      87,   167,   351,   352,   355,   382,   436,   617,   377,   381,
     656,   382,   377,   377,   391,   104,   106,   104,   106,   382,
     377,   377,   395,   394,   318,   662,   456,   459,     3,     3,
     425,   425,    15,   425,   604,     3,   604,     3,   121,   121,
     554,    27,   550,   550,   550,   550,   550,   383,   379,   526,
     550,   527,   529,   550,   383,   550,   511,    19,    49,    84,
     157,   158,   159,   160,   161,   162,   163,   177,   180,   520,
     521,   546,   547,   551,   556,   377,   379,   119,    20,   397,
     443,   445,    97,    98,    99,   100,   561,   565,   561,   566,
     394,   570,   377,   377,   383,   377,   377,   391,   377,   377,
     377,   377,   377,   377,   599,   603,   393,   283,   284,   319,
     283,   393,   581,   308,   396,   583,   584,   582,   321,   393,
     377,   324,   600,   622,   629,   396,   630,   635,   618,   619,
     396,   377,   655,   461,   377,    20,   399,   399,   399,   399,
     395,   391,     3,     3,    15,    15,   379,   379,   379,   379,
     383,   550,   379,   383,    15,   379,    22,   378,    22,   378,
     550,   550,   550,   382,   556,   549,   671,   377,   550,   552,
     553,   512,    15,   397,   446,   381,   564,    30,   217,   567,
     391,   377,   446,   391,   391,   393,   391,   381,   425,   381,
     381,   391,   391,   381,   446,   381,   634,   381,   394,   636,
     641,    20,   381,   642,   647,   212,   231,   269,   331,   382,
     654,   464,   377,   377,   377,   377,   480,   480,   550,   379,
       7,    28,   529,   382,   550,   555,   550,   546,   377,   178,
     381,    22,    22,    32,   383,   377,   121,   564,   563,    19,
      20,   218,   568,   377,   600,   592,   585,   592,   588,   381,
     628,   633,   632,   637,   643,   139,   140,   288,   449,   391,
     270,   291,   361,   362,   363,   364,   653,   377,   464,   464,
     464,   464,     3,     3,   379,   378,   379,     7,   379,   377,
     379,   377,   671,   381,   522,   556,   539,   550,   550,    90,
     146,   147,   201,   206,   553,    15,   105,   209,   210,   213,
     214,   382,   562,   394,   215,   569,   381,   602,   382,   396,
     593,   594,   143,   283,   306,   382,   586,   382,   235,   285,
     286,   287,   289,   300,   382,   460,   589,   627,   626,   344,
     345,   348,   349,   350,   382,   631,   640,   646,   391,   391,
     391,   212,   393,   526,   529,   379,   520,   179,     6,    15,
      16,    17,   378,   382,   523,   525,   528,   531,   533,   535,
     377,   377,   378,   378,   378,   378,   377,   377,   393,   211,
     212,   212,   391,   392,   391,   377,   393,   601,   306,   314,
     595,   393,   391,   393,   377,   391,   391,   391,   233,   113,
     391,    91,   299,   302,   377,   119,   167,   209,   229,   308,
     336,   337,   340,   341,   343,   351,   352,   382,   623,   347,
     347,   393,   393,   393,   377,   347,   353,   382,   638,   347,
     354,   382,   644,   309,   383,   379,   377,   382,   522,   520,
     550,     7,   380,   383,   550,   550,   550,   550,   213,   213,
     213,    38,    39,    40,    64,   151,   208,   211,   212,   235,
     269,   281,   283,   285,   286,   287,   288,   289,   290,   296,
     300,   301,   304,   317,   325,   382,   460,   591,   391,   377,
     391,   391,   335,   635,   233,   335,   347,   339,   393,   338,
      71,   342,   227,   218,   624,   218,   625,   377,   391,   391,
     346,   391,   648,   636,   639,   377,   648,   642,   645,   377,
     526,   379,   378,   525,   520,   533,   379,   379,   379,   379,
     392,   392,   392,   308,   381,   393,   310,   288,   449,   391,
     270,   393,   391,   391,   391,   233,   391,   113,   391,   291,
     292,   293,   294,   295,   296,   297,   298,   326,    91,   299,
     302,   293,   391,   318,   291,   377,   213,   391,   213,   391,
     391,   393,   391,   391,    95,   393,   641,   393,   647,   356,
     649,   649,   391,   379,   550,   377,   377,   377,   377,   393,
     596,   311,   312,   391,   391,   212,   393,   391,   391,   393,
     393,   391,   393,   391,   391,   649,   391,   393,    18,   382,
     598,   309,   303,   597,   377
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 708 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 709 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 722 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 732 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 733 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 740 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 741 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 742 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 750 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 751 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 752 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 753 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 754 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 755 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 762 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 769 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 770 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 774 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 782 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 786 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 790 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 797 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 805 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 806 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 812 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 821 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 822 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 826 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 831 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 832 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 836 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 837 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 841 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 842 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 846 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 847 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 848 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 849 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 850 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 851 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 852 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 853 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 854 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 860 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 861 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 870 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 871 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 872 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 873 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 876 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 877 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 878 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 879 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 880 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 881 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 893 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 896 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 903 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 906 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 909 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 912 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 915 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 920 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 921 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 922 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 930 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 935 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 936 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 940 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 947 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 953 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 958 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 962 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 976 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 990 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 991 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 995 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 997 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 1016 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1017 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1018 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1019 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1026 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1027 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1031 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1039 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1045 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 1059 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 1060 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1064 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1070 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1074 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1086 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1090 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1091 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1092 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1093 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1094 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1095 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1096 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1097 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1098 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1099 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1100 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1101 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1105 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1107 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1108 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1112 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1113 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1114 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1115 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1116 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1120 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1126 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1130 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1138 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1139 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1147 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1155 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1156 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1157 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1161 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1162 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1175 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1187 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1188 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1194 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1207 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1221 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1222 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1223 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1228 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1232 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1233 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1234 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1235 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1236 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1237 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1243 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1244 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1245 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1250 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1254 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 1255 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1276 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1294 "cf-parse.y"
    { }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1295 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1296 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1297 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1298 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1299 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1308 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1311 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1314 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1317 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1321 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1325 "cf-parse.y"
    { if_show(); }
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 1328 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1332 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 1335 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 1340 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 1346 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1353 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1358 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1363 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1368 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1372 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1376 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1380 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1390 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1398 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1402 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1409 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1410 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1416 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1419 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1426 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1433 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1437 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1445 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1446 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1447 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1453 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1456 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1459 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1460 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1461 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1462 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1463 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1464 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1465 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1470 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1475 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1484 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1491 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1498 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1506 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1508 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1510 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1512 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1514 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1516 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1518 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1521 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1524 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1530 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1531 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1532 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1536 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1537 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1544 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1546 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1548 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1550 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1552 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1554 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1558 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1562 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1565 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1568 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1569 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1570 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1574 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1575 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1576 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1584 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1585 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1594 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1598 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1599 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1600 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1601 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1602 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1603 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1604 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1605 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1606 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1607 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1608 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1609 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1610 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1631 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1642 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1643 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1650 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1651 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1658 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1667 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1675 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1699 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1700 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1704 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1717 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1720 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1733 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1734 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1737 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1738 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1742 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1745 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1754 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1767 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1768 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1769 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1770 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1774 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 1775 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 1776 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 1777 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1778 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1782 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 1785 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1786 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1787 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1791 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1794 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1803 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1806 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1807 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 1808 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 1809 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1813 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1814 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 1815 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1821 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 1822 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1829 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1834 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 1839 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1843 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 1850 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 1851 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 1852 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1853 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 1860 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 1861 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 1864 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 341:
/* Line 1792 of yacc.c  */
#line 1865 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 1872 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 1884 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 1885 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 1889 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 1890 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 1894 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 1895 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 1896 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 1897 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 1898 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 1902 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 1903 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 1904 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 1908 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 1909 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 1910 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 1911 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 1912 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 1913 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 1914 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 1915 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 1916 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 1917 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 1918 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 1922 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 1923 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 1937 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 1960 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 1974 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 1975 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 1976 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 1977 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 1978 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 1979 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 1980 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 1981 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 1982 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 1983 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 1987 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 1988 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 1989 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 1990 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 1991 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 1992 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 1993 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 1994 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 1995 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 1996 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 1997 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 1998 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 1999 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2000 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2001 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2002 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 2004 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2005 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2006 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2008 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2010 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2012 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2014 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 2015 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2016 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2017 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2018 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2028 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2029 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2030 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2031 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2032 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2033 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2034 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2036 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2037 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2042 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2065 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2066 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2067 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2068 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2069 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2070 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2074 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2077 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2078 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2079 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2087 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2094 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2103 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2104 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2108 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2114 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2124 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2133 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2139 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2144 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2151 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2156 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2162 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2163 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2164 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 2172 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2173 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2174 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2175 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2176 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2183 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, sizeof(struct bfd_config), (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2210 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2221 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2222 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 2223 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 2224 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 2225 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 2226 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2240 "cf-parse.y"
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2243 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2247 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2248 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2249 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2253 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 2254 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 2258 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 2259 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 2263 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2281 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2286 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2310 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2311 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2312 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2322 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2323 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2324 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 2325 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 2326 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 2327 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 2328 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2329 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2330 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2331 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2332 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 2333 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2334 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2335 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 2336 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 2337 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2338 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2339 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2340 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2341 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2342 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2343 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2344 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 2345 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 2346 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 2347 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 2348 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 2349 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 2350 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 2351 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 2352 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 2353 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 2354 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 2355 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2356 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 2361 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 2362 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2363 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2364 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2365 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2366 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2367 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 2368 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 2379 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 2395 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 2396 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 2397 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 2398 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2399 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2403 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 2418 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2427 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2428 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2429 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 2430 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 2431 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 546:
/* Line 1792 of yacc.c  */
#line 2432 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2433 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2434 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2435 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 2436 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 2437 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2449 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 2463 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 563:
/* Line 1792 of yacc.c  */
#line 2464 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2465 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2469 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 566:
/* Line 1792 of yacc.c  */
#line 2470 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 570:
/* Line 1792 of yacc.c  */
#line 2479 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 2480 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 2481 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 2482 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 2483 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 2484 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 2485 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 577:
/* Line 1792 of yacc.c  */
#line 2486 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 2487 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2492 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2513 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 2514 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 2515 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 2516 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 2517 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 2518 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2519 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 2520 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2521 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 2522 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 2523 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 2524 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 2525 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2526 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 2527 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 2528 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2529 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2530 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2531 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2532 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2533 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2534 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2535 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2537 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2538 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2539 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2540 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2541 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2542 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2543 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2544 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2545 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2546 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 2547 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2559 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 2569 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2570 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2579 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2580 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2584 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 629:
/* Line 1792 of yacc.c  */
#line 2593 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 2618 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 636:
/* Line 1792 of yacc.c  */
#line 2632 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 2637 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2643 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 2646 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 2649 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 2654 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 2657 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 644:
/* Line 1792 of yacc.c  */
#line 2662 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2665 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2669 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 2672 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 2675 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 649:
/* Line 1792 of yacc.c  */
#line 2676 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 2677 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 2678 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 2679 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 2680 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 2681 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 655:
/* Line 1792 of yacc.c  */
#line 2682 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 2688 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 2697 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 660:
/* Line 1792 of yacc.c  */
#line 2702 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 2703 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 2710 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config), (yyvsp[(1) - (2)].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 2721 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2722 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2722 "cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2723 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2723 "cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 2724 "cf-parse.y"
    {
     RADV_CFG->trigger_prefix = (yyvsp[(2) - (2)].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[(2) - (2)].px).len;
     RADV_CFG->trigger_valid = 1;
   }
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 2741 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
}
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 2758 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); }
    break;

  case 676:
/* Line 1792 of yacc.c  */
#line 2759 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
    break;

  case 677:
/* Line 1792 of yacc.c  */
#line 2760 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); }
    break;

  case 678:
/* Line 1792 of yacc.c  */
#line 2761 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); }
    break;

  case 679:
/* Line 1792 of yacc.c  */
#line 2762 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 2763 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); }
    break;

  case 681:
/* Line 1792 of yacc.c  */
#line 2764 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 2765 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2766 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
    break;

  case 684:
/* Line 1792 of yacc.c  */
#line 2767 "cf-parse.y"
    {
     RADV_IFACE->default_lifetime = (yyvsp[(3) - (4)].i);
     if (((yyvsp[(3) - (4)].i) < 0) || ((yyvsp[(3) - (4)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 685:
/* Line 1792 of yacc.c  */
#line 2772 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 2773 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 2773 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 2774 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 2774 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 2775 "cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2776 "cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); }
    break;

  case 692:
/* Line 1792 of yacc.c  */
#line 2780 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2813 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2825 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2826 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); }
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 2827 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); }
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 2828 "cf-parse.y"
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 2833 "cf-parse.y"
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2841 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 2865 "cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2874 "cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 2881 "cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 2885 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
    break;

  case 720:
/* Line 1792 of yacc.c  */
#line 2909 "cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
    break;

  case 721:
/* Line 1792 of yacc.c  */
#line 2921 "cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 724:
/* Line 1792 of yacc.c  */
#line 2928 "cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
    break;

  case 725:
/* Line 1792 of yacc.c  */
#line 2932 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 2956 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; }
    break;

  case 731:
/* Line 1792 of yacc.c  */
#line 2957 "cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
    break;

  case 732:
/* Line 1792 of yacc.c  */
#line 2961 "cf-parse.y"
    { (yyval.i) = -1; }
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 2962 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 2968 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 737:
/* Line 1792 of yacc.c  */
#line 2977 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2978 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 2979 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 740:
/* Line 1792 of yacc.c  */
#line 2980 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 741:
/* Line 1792 of yacc.c  */
#line 2981 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 742:
/* Line 1792 of yacc.c  */
#line 2982 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 744:
/* Line 1792 of yacc.c  */
#line 2984 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 2985 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 746:
/* Line 1792 of yacc.c  */
#line 2986 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 748:
/* Line 1792 of yacc.c  */
#line 2991 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 749:
/* Line 1792 of yacc.c  */
#line 2992 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 2993 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 2998 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 2999 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 3000 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 754:
/* Line 1792 of yacc.c  */
#line 3001 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 3002 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 757:
/* Line 1792 of yacc.c  */
#line 3006 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 758:
/* Line 1792 of yacc.c  */
#line 3007 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 759:
/* Line 1792 of yacc.c  */
#line 3008 "cf-parse.y"
    { RIP_IPATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 760:
/* Line 1792 of yacc.c  */
#line 3009 "cf-parse.y"
    { RIP_IPATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 761:
/* Line 1792 of yacc.c  */
#line 3010 "cf-parse.y"
    { RIP_IPATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 3011 "cf-parse.y"
    { RIP_IPATT->ttl_security = 2; }
    break;

  case 767:
/* Line 1792 of yacc.c  */
#line 3025 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 3044 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 772:
/* Line 1792 of yacc.c  */
#line 3053 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 773:
/* Line 1792 of yacc.c  */
#line 3054 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 3058 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 776:
/* Line 1792 of yacc.c  */
#line 3067 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 777:
/* Line 1792 of yacc.c  */
#line 3075 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 778:
/* Line 1792 of yacc.c  */
#line 3082 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 779:
/* Line 1792 of yacc.c  */
#line 3083 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 780:
/* Line 1792 of yacc.c  */
#line 3087 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 781:
/* Line 1792 of yacc.c  */
#line 3092 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 782:
/* Line 1792 of yacc.c  */
#line 3098 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 783:
/* Line 1792 of yacc.c  */
#line 3101 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 784:
/* Line 1792 of yacc.c  */
#line 3106 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 785:
/* Line 1792 of yacc.c  */
#line 3107 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 786:
/* Line 1792 of yacc.c  */
#line 3108 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 787:
/* Line 1792 of yacc.c  */
#line 3109 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 788:
/* Line 1792 of yacc.c  */
#line 3110 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 789:
/* Line 1792 of yacc.c  */
#line 3114 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 854:
/* Line 1792 of yacc.c  */
#line 3122 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 855:
/* Line 1792 of yacc.c  */
#line 3122 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 858:
/* Line 1792 of yacc.c  */
#line 3122 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 867:
/* Line 1792 of yacc.c  */
#line 3125 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 868:
/* Line 1792 of yacc.c  */
#line 3125 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 869:
/* Line 1792 of yacc.c  */
#line 3125 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 870:
/* Line 1792 of yacc.c  */
#line 3125 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 871:
/* Line 1792 of yacc.c  */
#line 3126 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 872:
/* Line 1792 of yacc.c  */
#line 3126 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 873:
/* Line 1792 of yacc.c  */
#line 3127 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 874:
/* Line 1792 of yacc.c  */
#line 3128 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 875:
/* Line 1792 of yacc.c  */
#line 3129 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 876:
/* Line 1792 of yacc.c  */
#line 3130 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 877:
/* Line 1792 of yacc.c  */
#line 3131 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 878:
/* Line 1792 of yacc.c  */
#line 3132 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 879:
/* Line 1792 of yacc.c  */
#line 3133 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 880:
/* Line 1792 of yacc.c  */
#line 3134 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 881:
/* Line 1792 of yacc.c  */
#line 3135 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 882:
/* Line 1792 of yacc.c  */
#line 3136 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 883:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 884:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 885:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 886:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 887:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 888:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 889:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1792 of yacc.c  */
#line 9040 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3139 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

